/* ------------------------------------------------------------------------
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *	
 * 
 *
 *   Copyright Sussdorff & Roy 2001 (www.sussdorff-roy.com)
 *   
 *   Developers: Malte Fliedner  ( maltefliedner@aol.com )
 *               Bjoern Kiesbye  ( xkiesbye@aol.com , Bjhoern_Kiesbye@public.uni-hamburg.de )       
 * 
 * Acknowledgements
 * 
 * Special thanks to the Jabber Open Source contributors for their
 * suggestions and support of Jabber and to Malte Sussdorff for his support
 * and for giving us the possibility to work on this Project.
 * 
 * --------------------------------------------------------------------------*/
 



#include "../jabber/lib_jclient.h" 


char* CONFERENCE_SERVICE;
Jb_Conf_Room ConfRooms = NULL;
Jb_Conf_Room ConfRoomLast;
Ns_RWLock* ConfRoomsLock;

long int LargestRoomID = 0;
Ns_Mutex* LargestRoomIDLock;

long int LargestThreadID = 0; 
Ns_Mutex* LargestThreadIDLock;

pool ConfRoomsPool; 
xmlnode ConfCreatXml;
extern char* VIRTUAL_SERVER_NAME;
extern char* COMMUNITY_CLIENT;
extern char* JABBER_SERVER;
char* COMMUNITY_NICK;

//debug stuff
int ConfRoomsLockSet = 0;
int ConfRoomsLockWrSet = 0;
char* SecondToLast = NULL;
char* Last = NULL;

void Ns_RWLockRdLockCount(Ns_RWLock* lock)
{
  ConfRoomsLockSet++;
  SecondToLast = Last;
  Last = "Read";
  Ns_RWLockRdLock(lock);
  
  Ns_Log(Debug , "Ns_RWLockRdLock = %d , Last = %s , SecondToLast = %s " , ConfRoomsLockSet , Last , SecondToLast);

}

void Ns_RWLockWrLockCount(Ns_RWLock* lock)
{
  ConfRoomsLockSet++;
  SecondToLast = Last;
  Last = "Write";
  Ns_RWLockWrLock(lock);
  Ns_Log(Debug , " Ns_RWLockWrLock = %d , Last = %s , SecondToLast = %s " , ConfRoomsLockSet , Last , SecondToLast );

}

void Ns_RWLockUnlockCount(Ns_RWLock* lock)
{
  ConfRoomsLockSet--;
  SecondToLast = Last;
  Last = "Unlocked";
  Ns_RWLockUnlock(lock);
  Ns_Log(Debug , " Ns_RWLockUnlock = %d , Last = %s , SecondToLast = %s " , ConfRoomsLockSet , Last , SecondToLast );

}


//debug stuff end

// we need this references for the threads that are started by j_on_packet_handler (like it is done for invites)
extern JABBER_Conn *JABBERConn;
extern Ns_RWLock  *JConnLock; 

/* I've to take the locking out of the wrapers locking will be doen by 
      Jb_ConferenceMessage and Jb_ConferencePrecence.
*/




Jb_Conf_Room Jb_Get_Room(Jb_Conf_Room rooms ,char* roomname)
{
  Jb_Conf_Room cur;
  
  for(cur = rooms ; cur != NULL ; cur = cur->next)
    { if ( j_strcmp(cur->RoomName , roomname) == 0){return cur;} }
  
  return NULL;
}   

/* this function takes a jid naming the room  (roomname@server/nick)
   as argument, it returns the  jid that coresponds to the given nick.
   IMPORTANED:
   The returned jid is malloced from the passed jid's pool.  */

char* Jb_Get_Jid_From_Nick(char* id ,Jb_Conf_Room room)
{
   
   Jb_Conf_User cur;

   for(cur = room->RoomMembers ; cur != NULL ; cur = cur->next)
      {
        if(j_strcmp(cur->nick , id) == 0){return (cur->remote_id?cur->remote_id:id);}   
      }  
     
    return NULL;

}

Jb_Conf_User Jb_Get_User(char* id ,Jb_Conf_Room room)
{
   
   Jb_Conf_User cur;

   for(cur = room->RoomMembers ; cur != NULL ; cur = cur->next)
      {
        if(j_strcmp(cur->nick , id) == 0){return cur;}   
      }  
     
    return NULL;

}

char* Jb_GetUserIdFromJid(jid id)
{ 
  char* sql = NULL;
  char* user_id = NULL;
  pool p = NULL;
  int count = 0;

  p = pool_heap(500);
Ns_Log(Debug ,"Jb_GetUserIdFromJid %d , id = %s  " , count++ , jid_full(id)  ); 
  if(p == NULL || id == NULL)return NULL;
Ns_Log(Debug ,"Jb_GetUserIdFromJid %d  " , count++ ); 
  id->resource = NULL;
Ns_Log(Debug ,"Jb_GetUserIdFromJid %d  " , count++ ); 
  sql = pmalloc(p , (sizeof(char) * 300));
Ns_Log(Debug ,"Jb_GetUserIdFromJid %d  " , count++ ); 
  snprintf(sql , 501 ,"Select (jb_get_user_id('%s')) as user_id FROM dual" , id->user);  
//*********************************************sql-block**********************************************************************
{ 
  Ns_DbHandle *handle;
  Ns_Set *row;
  handle = Ns_DbPoolGetHandle("jabber");
  int dummy;

       Ns_Log(Debug ,"Jb_GetUserIdFromJid %d  " , count++ ); 
           if(handle)
             {	       row = Ns_Db1Row((Ns_DbHandle*) handle, sql);
	       if(row){
		
                   user_id = pstrdup(p,(char*)Ns_SetGet(row , "user_id")) ;
		  
		  
		 Ns_DbPoolPutHandle((Ns_DbHandle*)handle);
		 
	       }
	       else {
		 Ns_DbPoolPutHandle((Ns_DbHandle*)handle);
		 user_id = NULL;
	       }
	     } 
           else { Ns_Log(Debug , "Could not get a user_id from creator_jid .(Conference)");} 
                
}//sql block
  
Ns_Log(Debug ,"Jb_GetUserIdFromJid %d  " , count++ ); 
 return user_id;
   



} 

Jb_Conf_Room  Jb_Create_Room_Client(jid id ,char* RoomID)
{
  Jb_Conf_Room room;
  pool p;
  int i , end;

  p =  pool_heap( (sizeof(_Jb_Conf_Room) + sizeof(Ns_RWLock) + 200) );
  room =  pmalloc(p ,sizeof(_Jb_Conf_Room) );
  room->p = p;
  room->RoomMembers = NULL;
  room->RoomName = pmalloc(room->p,j_strlen(id->user)+1);
  room->real_room_jids = NULL;
    
  //copy the room name into the pool
    Ns_Log(Debug , "Create Room client 1");
  end = j_strlen(id->user);
  for(i = 0 ; i <= end ; i++)
    { room->RoomName[i] = id->user[i]; }
    Ns_Log(Debug , "Create Room client 2 : end = %d",end );
  room->RoomID = pmalloc(room->p , j_strlen(RoomID)+1);
  end = j_strlen(RoomID);

    Ns_Log(Debug , "Create Room client 3 : end = %d",end);
  for(i = 0 ; i <= end ; i++)
    { room->RoomID[i] = RoomID[i]; }

  room->lock = pmalloc(room->p, sizeof(Ns_RWLock));
  Ns_RWLockInit(room->lock);
  room->next = NULL;
     
  return room;
}


Jb_Conf_User Jb_Create_User_Client(char* nick ,char* prity_nick , char* remote_id , char* user_id )
{
  Jb_Conf_User user;
   pool p = pool_heap(300);
  
   user = pmalloc(p, sizeof(_Jb_Conf_User));
   user->p = p;
   user->nick = pstrdup(p,nick);
   user->prity_nick = pstrdup(p,prity_nick);
   user->remote_id = pstrdup(p, remote_id);
   user->user_id = pstrdup(p, user_id);
   user->next = NULL;
   user->status = NULL;

   return user;
}



/* This func has to be called with no conf locks set*/
void Jb_InsertNewRoom(Jb_Conf_Room new , Jb_Conf_Room rooms , int lock)
{ 
  Jb_Conf_Room cur = NULL;
  
  if(new == NULL || rooms == NULL )return;

  if(lock)
    { Ns_RWLockWrLockCount(ConfRoomsLock);/* Ns_RWLockWrLock(ConfRoomsLock); */}
   
  for(cur = rooms ; cur->next != NULL ; cur = cur->next){;}
    
     cur->next = new;
   
   

   if(lock) 
     { Ns_RWLockUnlockCount(ConfRoomsLock); /*Ns_RWLockUnlock(ConfRoomsLock);*/}

}




/*

void Jb_Insert_Or_Change_Member( jid jidroom , jid jidmemb , char* nick)
{ 
  Jb_Conf_Room room;
 
  Ns_RWLockRdLock(ConfRoomsLock);

   room = Jb_Get_Room( ConfRooms , jidroom->user );
   Ns_RWLockWrLock(room->lock);

  Ns_RWLockUnlock(ConfRoomsLock);
  
   Ns_SetUpdate(room->RoomMembers , nick , jid_full(jidmemb) );
  
   Ns_RWLockUnlock(room->lock);

}

*/
 
//Removes the room from the list and frees all of it's asosiated memory.

void Jb_DelConferenceRoom(Jb_Conf_Room rooms , jid jidroom , jconn conn)
{
  Jb_Conf_Room cur,last;
  Jb_Conf_User cur_u,cur_u2; 
  xmlnode pres;
  int count = 0;

  last = rooms;
  pres = jutil_presnew( JPACKET__UNAVAILABLE , jid_full(jidroom) , "Offline");
  xmlnode_put_attrib(pres , "from" , COMMUNITY_CLIENT);
  Ns_Log(Debug ,"jb_DelConferenceRoom 1"  ,  xmlnode2str(pres) );
  jab_send(conn , pres);  

Ns_Log(Debug ,"jb_DelConferenceRoom 2");
   
 Ns_RWLockWrLockCount(ConfRoomsLock);//Ns_RWLockWrLock(ConfRoomsLock);
Ns_Log(Debug ,"jb_DelConferenceRoom 3");
  for(cur = rooms; cur != NULL  ; cur = cur->next)
    {Ns_Log(Debug ,"jb_DelConferenceRoom 4");
      if( j_strcmp(cur->RoomName , jidroom->user) == 0) 
      {  Ns_Log(Debug ,"jb_DelConferenceRoom 5");  //Nobody kann now access the confrooms
          Ns_Log(Debug ,"jb_DelConferenceRoom 5.1 last->RoomName = %s , cur->RoomName = %s , last->next =%x , cur->next = %x",last->RoomName , cur->RoomName , last->next , cur->next);
          last->next = cur->next;         //no nobody can get a pointer to the Room obj.  
          Ns_RWLockDestroy(cur->lock);
          
          cur_u = cur->RoomMembers;
          while(cur_u)
	    {Ns_Log(Debug ,"jb_DelConferenceRoom 6.%d " , count++ );
	      cur_u2 = cur_u->next; pool_free(cur_u->p);cur_u=cur_u2;} //free all user pools 
             
          pool_free(cur->p); //free Room pool
        } 
      else   
	{Ns_Log(Debug ,"jb_DelConferenceRoom 7");
	  last = cur;
        }
    }    
  Ns_RWLockUnlockCount(ConfRoomsLock);// Ns_RWLockUnlock(ConfRoomsLock);
 Ns_Log(Debug ,"jb_DelConferenceRoom 8"); 
   xmlnode_free(pres);
}


xmlnode Jb_Get_Room_Creation_Xml(jconn conn)
{
  xmlnode new,cache;
  void * * get;
  pool p;
  int error;

  if(ConfCreatXml != NULL) return xmlnode_dup(ConfCreatXml);

  new = xmlnode_new_tag("iq");
  xmlnode_put_attrib(new , "type" , "get" ); 
  xmlnode_put_attrib(new , "to" , CONFERENCE_SERVICE );
  xmlnode_insert_tag(new , "create");
  xmlnode_get_tag(new ,"create");
  xmlnode_put_attrib(new , "ns" , "jabber:iq:conference");
  
  p = pool_heap(100);
  get = pmalloc(p,sizeof(void*));
  
  //error = Jb_Send_Wait_For_Response(conn , 20 ,  new , get);
  
  if(error != NS_OK) return NULL;
 
  ConfCreatXml = (xmlnode)get[0];
  
  xmlnode_hide_attrib(ConfCreatXml ,"from");
  xmlnode_put_attrib(ConfCreatXml , "to" , CONFERENCE_SERVICE);
  xmlnode_put_attrib(ConfCreatXml , "type" , "set" );

  return xmlnode_dup( ConfCreatXml );
      
} 

xmlnode Jb_Create_Room_Server(jconn conn, char* address , char *name , char* desc , int persistent)
{ xmlnode send, cache ,cratnod;
 int error;
 void * * ret;
 pool p = pool_heap(sizeof(void*));
 ret = pmalloc(p, sizeof(void*));
 
 send = Jb_Get_Room_Creation_Xml(conn);

 cratnod = xmlnode_get_tag(send , "create"); 
 
 cache = xmlnode_get_tag(cratnod , "address");
 if(address == NULL) xmlnode_hide(cache);
 else xmlnode_insert_cdata(cache , address , -1);
 
 cache = xmlnode_get_tag(cratnod , "metadata");
 xmlnode_insert_cdata(xmlnode_get_tag(cache , "name"), name ,-1);  
 xmlnode_insert_cdata(xmlnode_get_tag(cache , "desc"), desc ,-1);

 //error = Jb_Send_Wait_For_Response(conn , 20 , send , ret);

 if(error != NS_OK)return NULL;
 
 return (xmlnode)ret[0];  
}  





void Jb_ConferenceMessages(jpacket packet ) 
{ char* sql = NULL;
  char* jid_db = NULL;
  int error = 0;
  pool p;
  jid from_id = NULL;
  Jb_Conf_Room room = NULL,rooms;
  Jb_Conf_User user=NULL;

  if(packet == NULL || packet->x == NULL) return;

  p = pool_new();
  sql = pmalloc(p, sizeof(char)*1500);
      Ns_Log(Debug ,"Recived a subject change 0" );
  if(xmlnode_get_tag(packet->x,"subject") != NULL)
    {char* new_thread_id = NULL;
     char* new_subject = NULL;
     char* msg_id = NULL;

    //we have a subject change we have to write lock the room first get prepaered
  
     if( (new_subject = xmlnode_get_data(xmlnode_get_tag(packet->x , "subject")))  == NULL ) 
       {new_subject = "Not specified!!";}
  
     if( (msg_id = xmlnode_get_attrib(packet->x , "id")) != NULL   &&  j_strlen(msg_id) > (CONFERENCE_THREAD_ID_LEN + 2)  &&  msg_id[ CONFERENCE_THREAD_ID_LEN] == '_')
       {          Ns_Log(Debug , "Subject change with existing thread_id, msg_id = %s with  thread_id " , msg_id); 
         msg_id[ CONFERENCE_THREAD_ID_LEN] = '\0';
      
          Ns_Log(Debug , "Subject change with existing thread_id, msg_id = %s  with OUT thread_id " , msg_id); 
         if( j_strcmp(CONFERENCE_THREAD_ID , msg_id) == 0) 
           {
             new_thread_id = (msg_id + CONFERENCE_THREAD_ID_LEN + 1);
             Ns_Log(Debug , "Subject change with existing (new)_thread_id = %s" , new_thread_id);
	     msg_id[ CONFERENCE_THREAD_ID_LEN] = '_';
	   }
	 else 
	   {
	    msg_id[ CONFERENCE_THREAD_ID_LEN] = '_';
            Ns_Log(Debug , "Subject change with existing thread_id , no match of CONFERENCE_THREAD_ID new_thread_id = %s" , new_thread_id);
	   }
       
       } 
     


    Ns_RWLockRdLockCount(ConfRoomsLock);//Ns_RWLockRdLock(ConfRoomsLock);   
            Ns_Log(Debug ,"Recived a subject change 0.1" );     

     from_id = jid_new(p, xmlnode_get_attrib(packet->x,"from")); 
     if(from_id == NULL || from_id->user )       Ns_Log(Debug ,"Recived a subject change 0.2 , %d" ,from_id , from_id->user ); 
     room = Jb_Get_Room(ConfRooms , from_id->user);

      Ns_Log(Debug ,"Recived a subject change 1" );
     if(room == NULL )
      {
        Ns_Log(Debug ,"Recived a subject change for a conference room that does not exist. xml:\n" , xmlnode2str(packet->x));
        pool_free(p); 
	Ns_RWLockUnlockCount(ConfRoomsLock);//Ns_RWLockUnlock(ConfRoomsLock);
        return;
      }

      Ns_RWLockRdLock(room->lock);
      jid_db = Jb_Get_Jid_From_Nick(from_id->resource , room);
      user = Jb_Get_User (from_id->resource,room);      
      Ns_Log(Debug ,"Recived a subject change 1.2" );

      if(user == NULL && *(from_id->resource) == '\0' )
       {
          Ns_Log(Debug ,"Recived a subject change 1.2.1" );
	 jid_db = Jb_Get_Jid_From_Nick(COMMUNITY_NICK , room);
         user = Jb_Get_User(COMMUNITY_NICK , room);
       }
      else if(user == NULL && from_id->resource != NULL)
	{
         Ns_Log(Debug ,"Recived a subject change 1.2.2" );
	 pool_free(p); 
         Ns_RWLockUnlock(room->lock);
	 Ns_RWLockUnlockCount(ConfRoomsLock);//Ns_RWLockUnlock(ConfRoomsLock);
         return;
	}

      

      Ns_Log(Debug ,"Recived a subject change 1.3" );
      
      

      
      snprintf(sql , 1501 , "begin  jb_conference_thread_finish('%s'); end;" , room->ThreadID);   
      error = JABBER_Dbml(sql);   

      Ns_Log(Debug ,"Recived a subject change 2" );
   
      //See if we got a thread_id with the subject change, we get it incase users restart a thread (topic , subject), to append the stored 
      //message flowe on a Topic
  
      if(new_thread_id == NULL)
        {
	  //No , we have to create a new one.

          new_thread_id = Jb_ConfGetNextThreadID(p);

         if(user->user_id != NULL){
           snprintf(sql , 1501 , "begin jb_conference_thread_new ('%s' ,  '%s' , '%s' , '%s' , '%s'); end;" , new_thread_id ,room->RoomID ,  xmlnode_get_data( xmlnode_get_tag(packet->x,"subject") ) , jid_db  , user->user_id);
          }
         else 
          {
           snprintf(sql , 1501 , "begin jb_conference_thread_new ('%s' ,  '%s' , '%s' , '%s' , 'null'); end;" , new_thread_id ,room->RoomID ,  xmlnode_get_data( xmlnode_get_tag(packet->x,"subject") ) , jid_db );

          }
       
         error = JABBER_Dbml_Direckt(sql);

	}
      else
	{
          // Yes ,we recived a thread_id with the subject change xml document from the jabber server.

	  error = NS_OK;

	}     


       Ns_Log(Debug ,"Recived a subject change 3" );   
      if(error != NS_OK)
	{
          Ns_Log(Debug ,"Subject change , new thread insert dml error. xml:\n" , xmlnode2str(packet->x));
          pool_free(p); 
          Ns_RWLockUnlock(room->lock);
	  Ns_RWLockUnlockCount(ConfRoomsLock);//Ns_RWLockUnlock(ConfRoomsLock);
         return;
        }

      //we created a new thraed entry in the db ,now update the room instance in the.
      //We have to unlock every thing and aquire a write lock from the bottom.
          Ns_RWLockUnlock(room->lock);
	  Ns_RWLockUnlockCount(ConfRoomsLock);//Ns_RWLockUnlock(ConfRoomsLock);

	  user = NULL;
          room = NULL;
          jid_db = NULL;

	  Ns_RWLockWrLockCount(ConfRoomsLock);// Ns_RWLockWrLock(ConfRoomsLock);   
                 Ns_Log(Debug ,"Recived a subject change 4,%s", from_id->user );
           
     room = Jb_Get_Room(ConfRooms , from_id->user);
    
     //hell lot to do just to change a single variable :P

     if(room == NULL )
      {
        Ns_Log(Debug ,"Recived a subject change for a conference room after thread_id change the room does not exist xml:\n %s" , xmlnode2str(packet->x));
        pool_free(p); 
	Ns_RWLockUnlockCount(ConfRoomsLock);//Ns_RWLockUnlock(ConfRoomsLock);
        return;
      }

      Ns_RWLockWrLock(room->lock);
            Ns_Log(Debug ,"Recived a subject change 5" );
      //now that we have the write locks we can update the room inctance

      room->ThreadID = pstrdup(room->p , new_thread_id);
      room->subject = pstrdup(room->p , new_subject );

      jid_db = Jb_Get_Jid_From_Nick(from_id->resource , room);
      user = Jb_Get_User (from_id->resource,room);      



      if(user == NULL && *(from_id->resource) == '\0' )
       {

	 jid_db = Jb_Get_Jid_From_Nick(COMMUNITY_NICK , room);
         user = Jb_Get_User(COMMUNITY_NICK , room);
       }
      else if(user == NULL && from_id->resource != NULL)
	{

	 pool_free(p); 
         Ns_RWLockUnlock(room->lock);
	 Ns_RWLockUnlockCount(ConfRoomsLock);//Ns_RWLockUnlock(ConfRoomsLock);
         return;
	}



      /*
      if(user == NULL )
       {
         Ns_Log(Debug ,"Recived a message for a conference room from some one whos not a member of the room. xml:\n" , xmlnode2str(packet->x));
         pool_free(p); 
         Ns_RWLockUnlock(room->lock);
         Ns_RWLockUnlock(ConfRoomsLock);
         return;
       }
      */
      if(user->user_id != NULL){
  snprintf(sql , 1501 , "begin jb_conference_message( '%s' , '%s' , '%s'  , '%s' , '0'); end;" , jid_db , xmlnode_get_data( xmlnode_get_tag(packet->x,"body") ) , room->RoomID , room->ThreadID , user->user_id);   
      } 
      else 
      {
      snprintf(sql , 1501 , "begin jb_conference_message( '%s' , '%s' , '%s'  , '%s' , '0'); end;" , jid_db , xmlnode_get_data( xmlnode_get_tag(packet->x,"body") ) , room->RoomID , room->ThreadID );     
      }

    error = JABBER_Dbml(sql);

   if(error == -1)
      {
       Ns_Log(Debug ,"Recived a message for a conference room, error during SQL insert xml:\n" , xmlnode2str(packet->x));
       pool_free(p); 
       Ns_RWLockUnlock(room->lock);
       Ns_RWLockUnlockCount(ConfRoomsLock);//Ns_RWLockUnlock(ConfRoomsLock);
       return;
     }

       pool_free(p);
       Ns_RWLockUnlock(room->lock);
        Ns_RWLockUnlockCount(ConfRoomsLock);//Ns_RWLockUnlock(ConfRoomsLock);  
       /*################################################################################################################################*/
       /*# finish of the subject change block in the if , the normal message protocol starts now                                        #*/
       /*################################################################################################################################*/
       

    }else{ 
      Ns_RWLockRdLockCount(ConfRoomsLock);//Ns_RWLockRdLock(ConfRoomsLock);   
     rooms = ConfRooms; 
    
  p = pool_new();
  from_id = jid_new(p, xmlnode_get_attrib(packet->x,"from")); 
  
  room = Jb_Get_Room(rooms , from_id->user);
  

    if(room == NULL )
     {
       Ns_Log(Debug ,"Recived a message for a conference room that does not exist. xml:\n" , xmlnode2str(packet->x));
       pool_free(p); 
       Ns_RWLockUnlockCount(ConfRoomsLock);//Ns_RWLockUnlock(ConfRoomsLock);
       return;
     }
    
        Ns_RWLockRdLock(room->lock);

       jid_db = Jb_Get_Jid_From_Nick(from_id->resource , room);     
       user = Jb_Get_User (from_id->resource,room);    



if(user == NULL && from_id->resource == '\0' )
       {
         Ns_Log(Debug ,"Recived a message for a conference room from the Conference Server. xml:%s\nresource= %c" , xmlnode2str(packet->x), from_id->resource);
	 jid_db = Jb_Get_Jid_From_Nick(COMMUNITY_NICK , room);
         user = Jb_Get_User(COMMUNITY_NICK , room);
       }
      else if(user == NULL && from_id->resource != NULL)
	{

	 pool_free(p); 
         Ns_RWLockUnlock(room->lock);
	 Ns_RWLockUnlockCount(ConfRoomsLock);//Ns_RWLockUnlock(ConfRoomsLock);
         return;
	}


       /*    if(user == NULL )
     {
       Ns_Log(Debug ,"Recived a message for a conference room from some one whos not a member of the room. xml:\n" , xmlnode2str(packet->x));
       pool_free(p); 
       Ns_RWLockUnlock(room->lock);
       Ns_RWLockUnlock(ConfRoomsLock);
       return;
     }
       */



 
  sql = pmalloc(p, sizeof(char)*1500);
  
  if(user->user_id){
  snprintf(sql , 1501 , "begin jb_conference_message( '%s' , '%s' , '%s'  , '%s' , '%s'); end;" , jid_db , xmlnode_get_data( xmlnode_get_tag(packet->x,"body") ) , room->RoomID , room->ThreadID , user->user_id);   
  } else { 

    snprintf(sql , 1501 , "begin jb_conference_message( '%s' , '%s' , '%s'  , '%s' , '0'); end;" , jid_db , xmlnode_get_data( xmlnode_get_tag(packet->x,"body") ) , room->RoomID , room->ThreadID );   

  }
   error = JABBER_Dbml(sql);

   if(error == -1)
      {
       Ns_Log(Debug ,"Recived a message for a conference room, error during SQL insert xml:\n" , xmlnode2str(packet->x));
       pool_free(p); 
       Ns_RWLockUnlock(room->lock);
       Ns_RWLockUnlockCount(ConfRoomsLock);//Ns_RWLockUnlock(ConfRoomsLock);
       return;
     }

    
   pool_free(p);
   Ns_RWLockUnlock(room->lock);
   Ns_RWLockUnlockCount(ConfRoomsLock);//Ns_RWLockUnlock(ConfRoomsLock);  
    }

}

void Jb_ConferencePresence(jpacket packet)
{
    Jb_Conf_User user = NULL ,cur = NULL ,cur_b = NULL;
    Jb_Conf_Room room = NULL , cur_room = NULL;
    jid id , id_to;
    pool p = pool_new();

              
    id = jid_new(p, xmlnode_get_attrib(packet->x, "from"));
    id_to =  jid_new(p, xmlnode_get_attrib(packet->x, "to"));         
    Ns_RWLockRdLockCount(ConfRoomsLock);//Ns_RWLockRdLock(ConfRoomsLock); 

    room = Jb_Get_Room(ConfRooms , id->user);
      Ns_Log(Debug ,"Recived a Presence for a conference room the rooms pointer is =%x:\nto: %s  ,, from:  %s" , room, jid_full(id_to) , jid_full(id)); 
      if(room == NULL){pool_free(p); Ns_RWLockUnlockCount(ConfRoomsLock); /*Ns_RWLockUnlock(ConfRoomsLock);*/ return;}

    Ns_RWLockRdLock(room->lock);

    user = Jb_Get_User(id->resource , room);    
      Ns_Log(Debug ,"Recived a Presence for a conference room begin. xml:\n %s" , xmlnode2str(packet->x)); 
    if (user == NULL)
    {/*someone has entered the room*/ 
     /*asume it's 1.0 protokoll at this stage, we dont have a real jid so we don't have a user_id*/
     /* May we have to create the user with no real jid here, it will later be inserted by Jb_IqPacket wich handles the 
        respons of our Iq get xmlns=jabber:x:conference:jid  */  
      xmlnode cur_node = NULL;
      char* user_id = NULL;
      int count = 0, count2 = 0;         
      

      for(cur_node = room->real_room_jids ; cur_node != NULL ; cur_node = xmlnode_get_nextsibling(cur_node ))
        {         Ns_Log(Debug ,"Jb_ConferencePresence 1.%d im for :\n %s , " , count++ , xmlnode2str(cur_node));  
          

          if( j_strcmp(jid_full(id) , xmlnode_get_attrib(cur_node , "roomjid") ) == 0  ||
              j_strcmp(id->resource , xmlnode_get_attrib(cur_node , "nick") ) == 0) 
	  {  Ns_Log(Debug ,"Jb_ConferencePresence 2.%d im for  , " , count2++ ); 
           /* if we find a  node cur is not null and we can try to get the user_id, if not xmlnode_get_attrib will return NULL to be inserted as realjid in the user struct
              and the if to send the iq will trigger*/               
            user_id = Jb_GetUserIdFromJid( id_to = jid_new( p , xmlnode_get_attrib(cur_node , "remotejid")) );
            Ns_Log(Debug ,"Jb_ConferencePresence 2.%d im for, user_id = %s  , jid = %s" , count2++, user_id , jid_full(id_to) ); 
            break;
          }
        }


	user = Jb_Create_User_Client(id->resource ,id->resource , xmlnode_get_attrib(cur_node , "realjid") , user_id );
        user->status = "Online"; 
        
        Ns_RWLockUnlock(room->lock);
        Ns_RWLockWrLock(room->lock);
    
	for(cur =  room->RoomMembers ; cur->next != NULL ; cur = cur->next){}
        cur->next = user;

        Ns_RWLockUnlock(room->lock);
	Ns_RWLockUnlockCount(ConfRoomsLock);//Ns_RWLockUnlock(ConfRoomsLock);

        /*Now send a request for the real jid*/
        if(!cur_node)
	  { jid idnr = NULL;
	    idnr = jid_new(p , xmlnode_get_attrib(packet->x , "from"));
            idnr->resource = NULL;
	    cur_node = jutil_iqnew(JPACKET__GET , "jabber:x:conference:jid");
            xmlnode_put_attrib(cur_node , "to" , jid_full(idnr) );
	    xmlnode_hide(xmlnode_get_tag(cur_node , "query"));
	    xmlnode_insert_tag(cur_node , "x");
	    xmlnode_put_attrib(xmlnode_get_tag(cur_node , "x") , "xmlns" , "jabber:x:conference:jid");
	    jab_send(JABBERConn->conn , cur_node);
       Ns_Log(Debug ,"Recived a Presence for a conference room, sending iq jid xml:\n %s" , xmlnode2str(cur_node)); 
            xmlnode_free(cur_node);
          }
    Ns_Log(Debug ,"Recived a Presence for a conference room, some one has enterd. xml:\n" , xmlnode2str(packet->x)); 

    }
    else
    {/*just a status change*/
	if(j_strcmp(xmlnode_get_attrib(packet->x , "type") , "unavailable" ) == 0) 
        {/*sombody leaves the room*/
         Ns_Log(Debug ,"Recived a Presence for a conference room, becomes unavailable. xml:\n" , xmlnode2str(packet->x)); 
	 Ns_RWLockUnlock(room->lock);
         Ns_RWLockWrLock(room->lock);
         if(j_strcmp(room->RoomMembers->nick , id->resource) == 0) 
	 { 
             user = room->RoomMembers; 
	     room->RoomMembers = room->RoomMembers->next;
             pool_free(user->p);
             
              Ns_RWLockUnlock(room->lock);
             /*what if it's the last user in the room , we have to destroy the whole room*/
            
             if(room->RoomMembers == NULL)
	     {  
	       Ns_RWLockUnlockCount(ConfRoomsLock);//Ns_RWLockUnlock(ConfRoomsLock);
	       Ns_RWLockWrLockCount(ConfRoomsLock);//Ns_RWLockWrLock(ConfRoomsLock);

		 if(j_strcmp(ConfRooms->RoomName , id->user) == 0)
		 { room = ConfRooms;
                   ConfRooms = room->next;
		   pool_free(room->p);
		 }
                 else
                 {
		     for(cur_room = ConfRooms; cur_room != NULL ; cur_room = cur_room->next)
		     {if(j_strcmp(cur_room->RoomName , id->user ) == 0)break;
		      room = cur_room;
                     }                   
     
                     room->next = cur_room->next;
                     pool_free(cur_room->p);  

                 }
		 Ns_RWLockUnlockCount(ConfRoomsLock);//Ns_RWLockUnlock(ConfRoomsLock);
	     } 

              
            

	 }
         else
         {
	 for(cur =  room->RoomMembers ; cur->next != NULL ; cur = cur->next)
          {if(j_strcmp(cur->nick , id->resource) == 0)break;
	   cur_b = cur;
	  }
	    cur_b->next = cur->next;  
            pool_free(cur->p);
            
	    Ns_RWLockUnlock(room->lock);
	    Ns_RWLockUnlockCount(ConfRoomsLock);//Ns_RWLockUnlock(ConfRoomsLock);

	    
         }


	}
        else 
        {/*change the status*/
	 char *state = NULL;
         Ns_Log(Debug ,"Recived a Presence for a conference room , state change. xml:\n" , xmlnode2str(packet->x)); 
         if( (state = xmlnode_get_data(xmlnode_get_tag(packet->x, "status"))) == NULL  &&  (state = xmlnode_get_data(xmlnode_get_tag(packet->x, "show"))) == NULL) state = "Online";
         
         Ns_RWLockUnlock(room->lock);
         Ns_RWLockWrLock(room->lock);
         user->status = pstrdup(user->p , state);
         Ns_RWLockUnlock(room->lock);
	 Ns_RWLockUnlockCount(ConfRoomsLock);//Ns_RWLockUnlock(ConfRoomsLock);
	}
    }

    pool_free(p);
}

void Jb_ConferenceIq(jpacket packet)
{xmlnode user_node = NULL , cur_node = NULL;
 jid room_jid = NULL;
 jid user_jid = NULL;
 char* nick = NULL;
 pool p = pool_heap(255);
 Jb_Conf_Room room = NULL;
 Jb_Conf_User user = NULL, cur = NULL;

  Ns_Log(Debug , "IQ Packet 001");

 if( (jpacket_subtype(packet) == JPACKET__SET) && (user_node = xmlnode_get_tag(xmlnode_get_tag(packet->x, "conference"),"user") ) && ( j_strcmp(xmlnode_get_attrib(user_node , "xmlns") , "jabber:iq:browse") == 0) )
   { 
     room_jid = jid_new(p, xmlnode_get_attrib(packet->x , "from"));
     user_jid = jid_new(p, xmlnode_get_attrib(user_node , "jid"));
     nick = xmlnode_get_attrib(user_node , "nick");
 Ns_Log(Debug , "IQ Packet Room in  01");
     if( room_jid == NULL || user_jid == NULL || nick == NULL){pool_free(p);return;}
    
     Ns_RWLockRdLockCount(ConfRoomsLock);//Ns_RWLockRdLock(ConfRoomsLock);

     room =   Jb_Get_Room(ConfRooms , room_jid->user);
     if( room == NULL ){pool_free(p); Ns_RWLockUnlockCount(ConfRoomsLock);/*ConfRoomsLock*/return;}
     Ns_RWLockWrLock( room->lock);

     user =  Jb_Get_User( user_jid->resource ,room);

          if( user == NULL )
            {//some one has entered the room
	      user = Jb_Create_User_Client(user_jid->resource , nick ,jid_full(user_jid), NULL );
	      user->status = pstrdup(user->p ,"Online");
              for(cur = room->RoomMembers; cur->next != NULL ; cur = cur->next);
              cur->next = user;

	    }

	  

     Ns_RWLockUnlock(room->lock);         
     Ns_RWLockUnlockCount(ConfRoomsLock);//Ns_RWLockUnlock(ConfRoomsLock);
     
     pool_free(p);  
     



    }
 else if (jpacket_subtype(packet) == JPACKET__RESULT &&  j_strcmp(xmlnode_get_attrib( xmlnode_get_tag(packet->x , "x") , "xmlns") , "jabber:x:conference:jid") == 0)
   { int counter = 0 , counter2 = 0;
     Ns_Log(Debug , "Jb_ConferenceIq  JPACKET__Result jabber:x:conference:jid ");
     room_jid = jid_new(p , xmlnode_get_attrib(packet->x , "from"));
     user_node = xmlnode_get_tag(xmlnode_get_tag(packet->x , "x") , "member" );
 
     if(room_jid == NULL || room_jid->user == NULL || user_node == NULL ){pool_free(p);return;}
    
      Ns_Log(Debug , "Jb_ConferenceIq  JPACKET__Result jabber:x:conference:jid 1 ");
     Ns_RWLockRdLockCount(ConfRoomsLock);//Ns_RWLockRdLock(ConfRoomsLock);   

     room = Jb_Get_Room(ConfRooms , room_jid->user);   
      Ns_Log(Debug , "Jb_ConferenceIq  JPACKET__Result jabber:x:conference:jid 2");  
     if(room == NULL) { Ns_RWLockUnlockCount(ConfRoomsLock);pool_free(p);return;  Ns_Log(Debug , "IQ jabber:x:conference:jid no room associated");}    
      
     Ns_RWLockWrLock(room->lock);
      Ns_Log(Debug , "Jb_ConferenceIq  JPACKET__Result jabber:x:conference:jid 3");
     if(room->real_room_jids ==  NULL ) {room->real_room_jids = user_node;}
     else {xmlnode_free(room->real_room_jids); room->real_room_jids = user_node;}
   
     for(user = room->RoomMembers ; user != NULL ; user = user->next)
       {
          Ns_Log(Debug , "Jb_ConferenceIq  JPACKET__Result jabber:x:conference:jid 4.%d ,user->remote_id = %s" ,counter , user->remote_id);
          counter++;
	 if(user->remote_id == NULL || *(user->remote_id) == '\0')
           {jid local_id = NULL;
          Ns_Log(Debug , "Jb_ConferenceIq  JPACKET__Result jabber:x:conference:jid 5 cur_node = %s " , xmlnode2str(room->real_room_jids));
	     for(cur_node = room->real_room_jids; cur_node != NULL ; cur_node = xmlnode_get_nextsibling(cur_node) )
	       { local_id = jid_new(p, xmlnode_get_attrib(cur_node , "roomjid"));
                                    
                 if( (j_strcmp(user->nick , xmlnode_get_attrib(cur_node , "nick")) == 0 ) || (j_strcmp(user->nick  , local_id->resource ) == 0 ) )
                   {char* user_id = NULL;
                              
                     user->remote_id = pstrdup(user->p , xmlnode_get_attrib(cur_node ,"remotejid"));
                              Ns_Log(Debug , "Jb_ConferenceIq  JPACKET__Result jabber:x:conference:jid user->remote_id = %s" , user->remote_id);
		      if((user_id = Jb_GetUserIdFromJid( jid_new( p, xmlnode_get_attrib( cur_node , "remotejid") ) ) ) ) user->user_id = pstrdup(user->p , user_id);
		       break; 
		   }
                
               }  
    
           }
       }
 
     Ns_RWLockUnlock(room->lock);   
     Ns_RWLockUnlockCount(ConfRoomsLock);//Ns_RWLockUnlock(ConfRoomsLock);
     pool_free(p);
   }  


}

int Jb_CreateConferenceRoom(char* RoomName, char* user_id , char* ThreadName , char* creator_jid , char* description , jconn conn , char* thread_id)
{ jid id,jid_room;
  pool p;
  Jb_Conf_Room room = NULL;
  char* sql;
  char* room_id = NULL;
  Jb_Conf_User user = NULL;  
  int error;
  xmlnode pres;
  p = pool_new();
  id = jid_new(p, creator_jid);
  sql = pmalloc(p, sizeof(char) * 500 );
  jid_room = jid_new(p,RoomName);


  //  room_id = "33";
  //thread_id = "33";

  if(jid_room->user == NULL) 
  {
      jid_set(jid_room , CONFERENCE_SERVICE , JID_SERVER);
      jid_set(jid_room , RoomName , JID_USER); 
  }  

    if((RoomName == NULL) || ((user_id == NULL) && (creator_jid == NULL) ) ) return CONFERENCE_ERROR;
                             Ns_Log(Debug , "Presence Room in jb_conferenceclient 01");
    if(user_id == NULL && (j_strcmp(id->server , JABBER_SERVER) == 0) )
    { //See if we can find it throug the creator jid
                             Ns_Log(Debug , "Presence Room in jb_conferenceclient 02");
			     user_id = pstrdup(p,Jb_GetUserIdFromJid(id));

    } 
    else if (creator_jid == NULL)
    {//See if we can find a creator_jid 
      snprintf(sql , 501 , "Select (jb_get_jid ('%s')) as screen FROM dual" , user_id); 

//***********************************************sql-block*******************************************************************

{ 
  Ns_DbHandle *handle = NULL;
  Ns_Set *row = NULL;
  handle = Ns_DbPoolGetHandle("jabber");
  
       
           if(handle)
             {
	       row = Ns_Db1Row((Ns_DbHandle*) handle, sql);
	       if(row)
                 {
		   if(  ( creator_jid = (char*)Ns_SetGet(row , "screen") )  &&  ( j_strcmp(creator_jid , "") != 0 )   ) 
                     {
		       creator_jid =   pstrdup(p,creator_jid);
		       Ns_DbPoolPutHandle((Ns_DbHandle*)handle);   
		     }
		   else
		     {
		       Ns_DbPoolPutHandle((Ns_DbHandle*)handle);
		       creator_jid = NULL;
		     }
		 }				 	       
	       else {
		      Ns_DbPoolPutHandle((Ns_DbHandle*)handle);
		      creator_jid = NULL;
	            }
              }	      
	   else { Ns_Log(Debug , "Could not get a jid from user_id (Conference)");} 
                
}//sql block


//++++++++++++++++++++++++++++++++++++++++++++++sql-block-ende++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++



    }    


// Get a Message id , and a thread id
//First See if we have an active room , then if there is a room in the db , else create a new one.
                             Ns_Log(Debug , "Presence Room in jb_conferenceclient 03");
  if ( Jb_Get_Room(  ConfRooms , RoomName) != NULL) 
   {   /*we dont have the conn (connection obj) available in this part of the client, we can not responde yet.
      if(creator_jid != NULL && where == CONFRERENCE_ROOM_LOCAL)
      {xmlnode x;
      char msg[200];

      snprintf(str , 201 , "The Room %s is Active, you can not create it!" , RoomName);
      x =  xmlnode jutil_msgnew("chat", creator_jid , NULL , msg) 
      xmlnode_put_attrib(x , "from" , COMMUNIY_CLIENT);
      jab_send()         
      }
    */
       pool_free(p);
       return CONFERENCE_ROOM_ACTIVE;
   }
  else 
   {
      

// ***************************************************sql-block****************************************************************


snprintf(sql ,501 , "select ( jb_conference_room_check('%s' ) ) as room_id from dual" , RoomName); 

{ 
  Ns_DbHandle *handle = NULL;
  Ns_Set *row = NULL;
  handle = Ns_DbPoolGetHandle("jabber");
  
       
           if(handle)
             {
	       row = Ns_Db1Row((Ns_DbHandle*) handle, sql);
	       if(row)
                 {
		   if (  ( room_id = (char*)Ns_SetGet(row , "room_id") ) &&  ( j_strcmp(room_id , "") != 0 ) )
		     {
		       room_id = pstrdup(p,(char*)Ns_SetGet(row , "room_id")) ;
		       Ns_Log(Debug , "Could  find a Room_id for Room Name %s, room_id=%s" , RoomName , room_id);
		       Ns_DbPoolPutHandle((Ns_DbHandle*)handle);
		     } 
                   else
                     {
		       Ns_Log(Debug , "Could NOT  find a Room_id for Room Name %s, room_id=%s" , RoomName , room_id);
		       Ns_DbPoolPutHandle((Ns_DbHandle*)handle);
                       room_id = NULL;
		     } 
	         } 
               else {
		 Ns_DbPoolPutHandle((Ns_DbHandle*)handle);
		 Ns_Log(Debug , "Could not find a Room_id for Room Name %s , no rows" , RoomName);
	            }
	     } 
	   else { Ns_Log(Debug , "Could not find a Room_id for Room Name %s" , RoomName);} 
                
}//sql block

//++++++++++++++++++++++++++++++++++++++++++++++++++++sql-block-end++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 

       if(room_id == NULL)
	{ 
          Ns_Log(Debug , "create  Room Name 002 %s" , RoomName);
          //create a new room entry in the table the  room id is returened by the room_new function in the db.  And Create a threadid.





 if(user_id != NULL) {
           snprintf(sql , 501 , "BEGIN jb_conference_rooms_new (  '%s' , '%s' , '%s' , '%s' ); END; " , user_id , creator_jid , RoomName , description);
 } else {
           snprintf(sql , 501 , "BEGIN jb_conference_rooms_new (  '0' , '%s' , '%s' , '%s' ); END;"  , creator_jid , RoomName , description);


}
	 
     error = JABBER_Dbml_Direckt(sql);
   
// There should be a room_id know available
// ***************************************************sql-block****************************************************************


snprintf(sql ,501 , "select ( jb_conference_room_check('%s' ) ) as room_id from dual" , RoomName); 

{ 
  Ns_DbHandle *handle = NULL;
  Ns_Set *row = NULL;
  handle = Ns_DbPoolGetHandle("jabber");
  
       
           if(handle)
             {
	       row = Ns_Db1Row((Ns_DbHandle*) handle, sql);
	       if(row)
                 {
		   if (  ( room_id = (char*)Ns_SetGet(row , "room_id") ) &&  ( j_strcmp(room_id , "") != 0 ) )
		     {
		       room_id = pstrdup(p,(char*)Ns_SetGet(row , "room_id")) ;
		       Ns_Log(Debug , "Could  find a Room_id for Room Name %s, room_id=%s" , RoomName , room_id);
		       Ns_DbPoolPutHandle((Ns_DbHandle*)handle);
		     } 
                   else
                     {
		       Ns_Log(Debug , "Could NOT  find a Room_id for Room Name %s, room_id=%s" , RoomName , room_id);
		       Ns_DbPoolPutHandle((Ns_DbHandle*)handle);
                       room_id = NULL;
		     } 
	         } 
               else {
		 Ns_DbPoolPutHandle((Ns_DbHandle*)handle);
		 Ns_Log(Debug , "Could not find a Room_id for Room Name %s , no rows" , RoomName);
	            }
	     } 
	   else { Ns_Log(Debug , "Could not find a Room_id for Room Name %s" , RoomName);} 
                
}//sql block

//++++++++++++++++++++++++++++++++++++++++++++++++++++sql-block-end++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++








       

	} //If room_id == NULL
 
//now we have a room_id get the thread_id we  have to create, unless a thread_id has been passed to us (this will be a thread restart).

       if (thread_id == NULL)          
        {
	  thread_id = Jb_ConfGetNextThreadID(p);


          if(user_id != NULL) {
    snprintf(sql , 501 , "begin jb_conference_thread_new ( '%s' ,  '%s' , '%s' , '%s'  , '%s'); end;" , thread_id , room_id , description  , creator_jid , user_id );
            } else {
    snprintf(sql , 501 , "begin jb_conference_thread_new ( '%s' ,  '%s' , '%s' , '%s'  , '0'); end;" , thread_id , room_id , description  , creator_jid );

            }

	}
    
      
   }

     


      if((room_id == NULL) || (thread_id == NULL)){ return CONFERENCE_ERROR;}
    
 

 
    error = JABBER_Dbml_Direckt(sql);


    //every thing is set up in the db_


    Ns_Log(Debug , "Create Room 1");
  
     room = Jb_Create_Room_Client(jid_room , room_id);  
    Ns_Log(Debug , "Create Room 2");

     if(room == NULL){pool_free(p); return CONFERENCE_ERROR;}
          Ns_Log(Debug , "Create Room 3");
     room->ThreadID = pstrdup(room->p , thread_id);
       Ns_Log(Debug , "Create Room 4");
     room->RoomName = pstrdup(room->p, RoomName);     
          Ns_Log(Debug , "Create Room 5");
     room->subject = pstrdup(room->p, description);
    Ns_Log(Debug , "Create Room 6");
//now create our user
     user =  Jb_Create_User_Client(COMMUNITY_NICK , COMMUNITY_NICK ,COMMUNITY_CLIENT , NULL );
     user->status = pstrdup(user->p ,  "Connecting");
    Ns_Log(Debug , "Create Room 7");
//user goes into room     
     room->RoomMembers = user;
//room goes into rooms list(procedure syc's it'self)
    Ns_Log(Debug , "Create Room 8room->name = %s , room->threadID = %s",room->RoomName,room->ThreadID );   
     Jb_InsertNewRoom(room , ConfRooms , 0);
    

// now send presence to the room
        Ns_Log(Debug , "Create Room 9");
     jid_set(jid_room , COMMUNITY_NICK , JID_RESOURCE);
     pres = jutil_presnew( 240 , jid_full(jid_room) , "Online" );     
     xmlnode_put_attrib(pres , "from" , COMMUNITY_CLIENT);

   if(0 == JCgetConnState ())
     jab_send(conn , pres);
    Ns_Log(Debug , "Create Room 10");
//free_everything up    
     pool_free(p);
     xmlnode_free(pres);

//return ok if we got till here
    Ns_Log(Debug , "Create Room 11");
     return CONFERENCE_OK;     
//now we have everything we need room_id,thread_id , (user_id || creator_jid ) , RoomName 




    /* Got everything to gether*/

}




               

Ns_Set* Jb_ActiveConferenceRooms(Jb_Conf_Room confrooms , Tcl_Interp *interp) 
{   int dummy;
    Ns_Set *rooms,*cur_room;
    Jb_Conf_Room cur = NULL;
    int count =0; 
    rooms = NULL;
     Ns_Log(Debug , "Active rooms first room name: %s", (char*)confrooms->RoomName);
    
     Ns_Log(Debug , "Active rooms first room 2 ");
    for(cur = confrooms ; cur != NULL ; cur = cur->next)
      {
         Ns_Log(Debug , "Active room %d.0.0 confrooms->next = %X cur->subject = %s" , count , confrooms->next , cur->subject );

	if(cur == NULL || cur->RoomName == NULL )break;
        if(j_strcmp(cur->RoomName , "Dummy") == 0)continue;
        if(count == 0)rooms =  Ns_SetCreate("Active Rooms");
        Ns_Log(Debug , "Active room %d.0.1" , count );
        Ns_Log(Debug , "Active room %d.0 ,  room name: %s", count ,cur->RoomName);
        count++;
        cur_room = Ns_SetCreate("cur->RoomName");
        Ns_Log(Debug , "Active room %d.1 ,  room name: %s", count ,cur->RoomName);
	dummy = Ns_SetPut(cur_room , "name" ,  cur->RoomName );
        Ns_Log(Debug , "Active room %d.2 ,  subject: %s", count ,cur->subject);
        dummy = Ns_SetPut(cur_room , "subject" ,   cur->subject );
	Ns_Log(Debug , "Active room %d.3 ,   Room ID: %s", count ,cur->RoomID);
        dummy = Ns_SetPut(cur_room , "roomid" ,  cur->RoomID );
        Ns_Log(Debug , "Active room %d.4 ,  thread id: %s", count ,cur->ThreadID);
        dummy = Ns_SetPut(cur_room , "threadid" ,  cur->ThreadID);
        if(TCL_OK == Ns_TclEnterSet(interp , cur_room , NS_TCL_SET_TEMPORARY | NS_TCL_SET_DYNAMIC) )
	{  Ns_Log(Debug , "Active room %d.5 ,  interp->result: %s", count , interp->result );
            Ns_Log(Debug , "Active room %d.6 ,  interp->result: %s", count , interp->result );
          dummy = Ns_SetPut(rooms , cur->RoomName , interp->result);  
             Ns_Log(Debug , "Active room %d.7 ,  interp->result: %s", count , interp->result );} 
      }

    Ns_Log(Debug , "Active rooms first room 3 count = %d",count);
   
    return rooms;
}    


Ns_Set* Jb_ActiveRoomMembers(char*  RoomName , Jb_Conf_Room confrooms , Tcl_Interp *interp)
{
    int dummy;
    Ns_Set* users = NULL;
    Ns_Set* cur_user = NULL;
    Jb_Conf_Room room = NULL;
    Jb_Conf_User cur = NULL;

     users = Ns_SetCreate("Room Members");
 Ns_Log(Debug ,"active mambers passed roomName. 0 " );    
 Ns_Log(Debug ,"active mambers passed roomName. %s " ,RoomName);
      
     if( (room = Jb_Get_Room(confrooms , RoomName)) != NULL )
      { Ns_Log(Debug ,"active mambers roomName. 2");
         Ns_RWLockRdLock(room->lock);
         Ns_Log(Debug ,"active mambers roomName. 3" );
               Ns_Log(Debug ,"active mambers roomName.4 %s" ,room->RoomName); 
	 for(cur = room->RoomMembers ; cur != NULL ; cur = cur->next)
	 {  cur_user = Ns_SetCreate("Room Member");
	    dummy = Ns_SetPut(cur_user , "nick" , (cur->prity_nick?cur->prity_nick:"Unknowen" ));
            dummy = Ns_SetPut(cur_user , "jid" , (cur->remote_id?cur->remote_id:"Unknowen" ) );
            dummy = Ns_SetPut(cur_user , "status" , (cur->status?cur->status:"Unknowen" ) );
            dummy = Ns_SetPut(cur_user , "user_id" , (cur->user_id?cur->user_id:"0" ) );    
           if(TCL_OK == Ns_TclEnterSet(interp , cur_user , NS_TCL_SET_TEMPORARY | NS_TCL_SET_DYNAMIC) )
	     {  
          dummy = Ns_SetPut(users , cur->nick , interp->result);   
             }
        
          }


	 Ns_RWLockUnlock(room->lock);
      }
     else
       {
         Ns_SetFree(users);
	 users = NULL;
       }
 Ns_Log(Debug ,"active mambers roomName.ende ");
     return users;

} 

int Jb_SendConferenceInvite(char* to , char* RoomName , char* subject , char* body , int type , jconn conn)
{

    xmlnode msg = NULL ,x;
    pool p;
    jid room_jid;
    jid to_jid;
    p = pool_heap(500);


    room_jid = jid_new(p,CONFERENCE_SERVICE);
    jid_set(room_jid , RoomName , JID_USER);
    
    to_jid = jid_new(p, to);
    
    if(charcheck(to_jid->user)) return JB_SPELL_ERROR;
    if(charcheck(room_jid->user)) return JB_SPELL_ERROR;
    
    if(type == 1)
      {
    msg = jutil_msgnew("chat", jid_full(to_jid) , subject , body);

    xmlnode_put_attrib(msg , "from" , COMMUNITY_CLIENT);
    xmlnode_insert_tag(msg , "x");
    x = xmlnode_get_tag(msg , "x");
    xmlnode_put_attrib(x , "xmlns" , NS_CONFERENCE);
    xmlnode_put_attrib(x ,"jid" , jid_full(room_jid));

    jab_send(conn , msg);
      }
    else if(type == 2)
      {
	msg = jutil_msgnew("groupchat", jid_full(room_jid) , "invite:" ,  body );

        xmlnode_insert_cdata( xmlnode_get_tag(msg , "subject") , jid_full(to_jid) , -1 );
        //xmlnode_hide(xmlnode_get_tag(msg , "body"));
	 xmlnode_insert_cdata( xmlnode_get_tag(msg , "body") , " subject : " , -1 );
        xmlnode_insert_cdata( xmlnode_get_tag(msg , "body") , subject , -1 );
        xmlnode_put_attrib(msg , "from" , COMMUNITY_CLIENT);
        Ns_Log(Debug , "Invite 2 xmll : %s" ,xmlnode2str(msg));
	jab_send(conn , msg);
      }	
 
    pool_free(p);
    if(msg)xmlnode_free(msg);
    return CONFERENCE_OK;
}

int  Jb_SendConferenceSubject(char*  room , char* subject , char* body , jconn conn , char* thread_id)
{
 
    xmlnode msg;
    pool p;
    jid room_jid;
    char msg_id[100]; 
    p = pool_heap(500);

 
    if(room == NULL  || subject == NULL || body == NULL) return CONFERENCE_ERROR;

    room_jid = jid_new(p,room);
    if(room_jid->user == NULL){ jid_set(room_jid , CONFERENCE_SERVICE , JID_SERVER); jid_set(room_jid, room , JID_USER);}

    msg = jutil_msgnew("chat", jid_full(room_jid) , subject , body);

    xmlnode_put_attrib(msg , "from" , COMMUNITY_CLIENT);

    if( thread_id != NULL)
      {
	snprintf(msg_id , 101 , "%s_%s" , CONFERENCE_THREAD_ID , thread_id);
        xmlnode_put_attrib(msg , "id" , msg_id);
      }

   
    jab_send(conn , msg);

 
    pool_free(p);
    xmlnode_free(msg);
    return CONFERENCE_OK;

}

void Jb_ConferenceInit()
{
  char* room_id = "0"; 
  char* thread_id = "0";

  ConfRoomsPool = pool_new();

  LargestRoomIDLock = pmalloc(ConfRoomsPool , sizeof(Ns_Mutex));
  LargestThreadIDLock = pmalloc(ConfRoomsPool , sizeof(Ns_Mutex));

  Ns_MutexInit(LargestRoomIDLock);
  Ns_MutexInit(LargestThreadIDLock);

  /*SQL-BLOCK*/ { 
  Ns_DbHandle *handle;
  Ns_Set *row;
  char* get_new_thread_id = "select thread_id FROM jb_conference_room_threads order by thread_id desc";
  char* get_new_room_id = "select room_id FROM jb_conference_rooms order by room_id desc";
  handle = Ns_DbPoolGetHandle("jabber");

       
           if(handle)
             {
	       row = Ns_DbSelect((Ns_DbHandle*) handle, get_new_thread_id);
	       if(row){
		 while(Ns_DbGetRow(handle , row) == NS_OK) 
                   {thread_id = pstrdup(ConfRoomsPool,(char*)Ns_SetGet(row , "thread_id")) ;
		   break; 
		   }
		 	 
	       }
	       else {
		 
		
	       }
	     } 
	   else { Ns_Log(Debug , "Could not get a new thread_id for a room creation");} 
                
                    

  LargestThreadID = j_atoi(thread_id, 1);
  Ns_Log(Debug , "Largetst thread_id after init int = %d , string = %s", LargestThreadID, thread_id);



  
  

  

       
           if(handle)
             {
	       row = Ns_DbSelect((Ns_DbHandle*) handle, get_new_room_id);
	       if(row){
		 while(Ns_DbGetRow(handle , row) == NS_OK) 
                   {room_id = pstrdup(ConfRoomsPool,(char*)Ns_SetGet(row , "room_id")) ;
		   break; 
		   }
		 Ns_DbPoolPutHandle((Ns_DbHandle*)handle);
		 
	       }
	       else {
		 Ns_DbPoolPutHandle((Ns_DbHandle*)handle);
		
	       }
	     } 
	   else { Ns_Log(Debug , "Could not get a new thread_id for a room creation");} 
                
                    }//sql block


  LargestRoomID = j_atoi(room_id , 1);
  Ns_Log(Debug , "Largetst room_id after init = %d , largest string val =%s", LargestRoomID , room_id);


}

//Returns the next ThreadID in String representation on the passed pool

char* Jb_ConfGetNextThreadID(pool p)
{
  char* thread_id = NULL;
  char* get_new_thread_id = "select ( jb_conference_next_thread_id ) as thread_id FROM dual";
  Ns_DbHandle *handle = NULL;
  Ns_Set *row = NULL;
  

  if(p == NULL) return NULL;

  
  
  handle = Ns_DbPoolGetHandle("jabber");

       
           if(handle)
             {
	       row = Ns_Db1Row((Ns_DbHandle*) handle, get_new_thread_id);
	       if(row)
                 {
                  if( (thread_id = (char*)Ns_SetGet(row , "thread_id") ) )
                    {
	             thread_id = pstrdup(p,  thread_id ) ;
		     Ns_DbPoolPutHandle((Ns_DbHandle*)handle);
                      Ns_Log(Debug , "Got a new thread_id for a thread creation thread_id=%s" , thread_id);
                    }
                  else { Ns_DbPoolPutHandle((Ns_DbHandle*)handle); }
		  }
		else { Ns_DbPoolPutHandle((Ns_DbHandle*)handle); }
             }
	   else { Ns_Log(Debug , "Could not get a new thread_id for a room creation"); } 
                
  





  /*
  Ns_MutexLock(LargestThreadIDLock);
  LargestThreadID++;
  snprintf(cache , 20 , "%d" , LargestThreadID);
  thread_id = pstrdup(p , cache);
    Ns_Log(Debug , "Largetst thread_id after Jb_getNextthreadid = %d", LargestThreadID);
  Ns_MutexUnlock(LargestThreadIDLock);
  */
  return thread_id;
}

//Returns the next RoomID in String representation on the passed pool

char *Jb_ConfGetNextRoomID(pool p)
{
  char* room_id = NULL;
  Ns_DbHandle *handle = NULL;
  Ns_Set *row = NULL;
  char* get_new_room_id = "select ( jb_conference_next_room_id ) as room_id FROM dual";
  handle = Ns_DbPoolGetHandle("jabber");


   
           if(handle)
             {
	       row = Ns_Db1Row((Ns_DbHandle*) handle, get_new_room_id);
	       if(row)
                 {
		   if( ( room_id = (char*)Ns_SetGet(row , "room_id") ) )
                     {   
                      room_id = pstrdup(p,  room_id );
		      Ns_DbPoolPutHandle((Ns_DbHandle*)handle);
                      Ns_Log(Debug , "Got a new room_id for a room creation room_id=%s" , room_id);
		     }
                   else { Ns_DbPoolPutHandle((Ns_DbHandle*)handle); }
	         }
	       else { Ns_DbPoolPutHandle((Ns_DbHandle*)handle); }
		
	       
	     } 
	   else { Ns_Log(Debug , "Could not get a new thread_id for a room creation");} 
           


  /*
  if(p == NULL) return NULL;
 Ns_Log(Debug , "create  Room Name, GetNextRoomId 001 ");
  Ns_MutexLock(LargestRoomIDLock);
 Ns_Log(Debug , "create  Room Name, GetNextRoomId 002 " );  
 LargestRoomID++;
  snprintf(cache , 20 , "%d" , LargestRoomID);
  room_id = pstrdup(p , cache);
   Ns_Log(Debug , "Largetst room_id after JbGetNextRoomid = %d", LargestRoomID);
   Ns_Log(Debug , "create  Room Name, GetNextRoomId 003 "); 
  Ns_MutexUnlock(LargestRoomIDLock);
  */

  return room_id;
}

void Jb_ReciveInviteV1(void* arg )
{
  // this schould run in a one thread .
  
  //1 . Create a new room representation
  //2. query for nicks and jids
  //3. enter the room
  pool p;
  char* RoomName;
  char* ThreadName;
  char* creator_jid;
  char* description;
  int result = CONFERENCE_OK;
  xmlnode invite = NULL;
  jid room_jid = NULL , from_jid = NULL;

  Ns_Log(Debug, "Jb_ReciveInviteV1 1");  
  invite = (xmlnode)arg; 
  p = pool_new();
  room_jid = jid_new(p,xmlnode_get_attrib(xmlnode_get_tag(invite , "x") , "jid") ); 
  RoomName =  room_jid->user;
  
  ThreadName =  xmlnode_get_data(xmlnode_get_tag(invite , "subject")) ;
  
  from_jid = jid_new(p , xmlnode_get_attrib(invite , "from"));
  
  creator_jid = jid_full(from_jid);

  description =  xmlnode_get_data(xmlnode_get_tag(invite , "message"));  
  Ns_Log(Debug, "Jb_ReciveInviteV1 2"); 
  //now lock the JABBERConn
    Ns_Log(Debug, "Jb_ReciveInviteV1 3 : RoomName = %s , ThreadName = %s , creator_jid = %s , description = %s  " , RoomName , ThreadName , creator_jid , description);
  Ns_RWLockRdLock(JConnLock);
  if(JABBERConn != NULL && JABBERConn->conn != NULL && JCgetConnState() == 0){
     Ns_Log(Debug, "Jb_ReciveInviteV1 4");
  result =  Jb_CreateConferenceRoom( RoomName,  NULL ,  ThreadName ,  creator_jid ,  description , JABBERConn->conn , NULL);
  }
 
   if(result != CONFERENCE_ROOM_ACTIVE)
    { char* to = NULL;
      char* from = NULL;
       from = pstrdup(p , xmlnode_get_attrib(invite ,"from") );
       to = pstrdup(p , xmlnode_get_attrib(invite ,"to"));

       xmlnode_put_attrib(invite ,"from"  ,to);
       xmlnode_put_attrib(invite ,  "to" , from);
 
      Ns_Log(Debug, "Jb_ReciveInviteV1 5 , xml : %s " , xmlnode2str(invite));
      jutil_error(invite , TERROR_CONFLICT);
      //     jutil_tofrom(invite);
      //jab_send(JABBERConn->conn ,invite);
   
    }
  else if(result == CONFERENCE_ERROR)
    { char* to = NULL;
    char* from = NULL;

       Ns_Log(Debug, "Jb_ReciveInviteV1 6");

       from = pstrdup(p , xmlnode_get_attrib(invite ,"from") );
       to = pstrdup(p , xmlnode_get_attrib(invite , "to"));
      
       xmlnode_put_attrib(invite , "from" ,to);
       xmlnode_put_attrib(invite ,  "to" , from);
 
      jutil_error(invite ,  TERROR_BAD);
      
      //jutil_tofrom(invite);
      Ns_Log(Debug, "Jb_ReciveInviteV1 6 xml: %s" , xmlnode2str(invite) );
      jab_send(JABBERConn->conn ,invite);
      
  
    }

   Ns_RWLockUnlock(JConnLock);

    Ns_Log(Debug, "Jb_ReciveInviteV1 7");
  pool_free(p);
  xmlnode_free(invite);
  
  Ns_ThreadExit(0);
}
