/* ------------------------------------------------------------------------
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *	
 * 
 *
 *   Copyright Sussdorff & Roy 2001 (www.sussdorff-roy.de)
 *   
 *   Developers: Malte Fliedner  ( maltefliedner@aol.com )
 *               Bjoern Kiesbye  ( xkiesbye@aol.com )       
 * 
 * Acknowledgements
 * 
 * Special thanks to the Jabber Open Source contributors for their
 * suggestions and support of Jabber and to Malte Sussdorff for his support
 * and for giving us the possibility to work on this Project.
 * 
 * --------------------------------------------------------------------------*/

//#include "../include/ns.h"
//#include "../include/nsdb.h"

#include "lib_jclient.h"

extern char *VIRTUAL_SERVER_NAME;
extern char *JABBER_SERVER;

Jb_DbPipe DbSystemPipe = NULL;
pool DbSystemPipePool = NULL;
Ns_Thread pipe_thread; 
Ns_Mutex pipe_mutex;
Ns_Event pipe_event;

  
void  JABBERStatusChange(jabber_buddy jb)
{ 
  //char* pool;    
  //  Ns_DbHandle *handle;
  int success;
  char query[4096];
  char* state;
  
  switch (jb->status) {
    case JABBER_ONLINE:
      state="online";
      break;
    case JABBER_AWAY:
      state="away";
      break;
    case JABBER_DND:
      state="dnd";
      break;
    case JABBER_XA: 
      state="xa";
      break;
    case JABBER_CHAT:
      state="chat";
      break;
    case JABBER_OFFLINE:
      state="offline";
      break;
    default:
      state="online";
      break;
      
  }  
  //  if(!(pool = Ns_DbPoolDefault(VIRTUAL_SERVER_NAME))) return;   
  //if(!(handle = Ns_DbPoolGetHandle(pool))) return;

  snprintf(query, 4096, "begin jb_update_status ('%s' , '%s' , '%s' , '%s');  end;", state, jb->resrc, jb->jid , jb->service);
   success = Jb_DbPipePoolAdd(DbSystemPipe, query); 
   Ns_Log(Notice ,"Jabber Jabberstatus Change PipePoolInsert , query: '%s' failed", query);
   /*success = Ns_DbDML(handle, query);*/

	if (success != 0) {
	  /*debug*/ 
	 Ns_Log(Error,"Jabber PipePoolInsert faild, query: '%s' failed", query);
        }
	
      
	//      Ns_DbPoolPutHandle(handle);
      pool_free(jb->p);
      return;     
  }
  

void JABBERCleanUp() {
  int success;
  char *pool;
  Ns_DbHandle *handle; 
  
  pool = Ns_DbPoolDefault(VIRTUAL_SERVER_NAME);   
  if ((handle = Ns_DbPoolGetHandle(pool)) != NULL) {
  
    success = Ns_DbDML(handle, "begin jb_clear_status; end;");
	if (success != NS_OK) {
	  /*debug*/ 
	  Ns_Log(Error, "Deleting jb_screen_names online data failed");
	}
    Ns_DbPoolPutHandle(handle);
  }else {
    /*debug*/ 
  }  

  }
  
 
 


void JABBERRegValidation(char *screen , char *value)
{
   char* pool;
  Ns_DbHandle *handle;
  char query[200]; 
  int success;
  /*
   pool = "jabber";
  if ((handle = Ns_DbPoolGetHandle(pool)) != NULL)
    {
*/
        snprintf(query , 200,  "begin jb_reg_validation( '%s' , '%s' ); end;", screen , value ); 
        Jb_DbPipePoolAdd(DbSystemPipe, query);

	//       success = Ns_DbDML(handle, query); 

       if (success != NS_OK) {
	  /*debug*/
	   Ns_Log(Error,"Jabber Database query: '%s' failed", query);
	}
       //	Ns_DbPoolPutHandle(handle);
        return;   

	//    } 

  } 
  
/*
void JABBERRegUpdate(JABBER_Conn* JABBERConn) {
  char* pool;
  Ns_DbHandle *handle;
  int success;
  char** argv;
  Ns_Log(Notice,"Updating jabber user registration requests ...");
   pool = Ns_DbPoolDefault(VIRTUAL_SERVER_NAME);
  if ((handle = Ns_DbPoolGetHandle(pool)) != NULL)
    {Ns_Set *row;
    row = Ns_DbSelect(handle, "Select j_screen, j_passwd from jabber_users where j_regstate = 'a'");
    if (row == NULL) {
      Ns_Log(Notice, "... no requests found"); 
      Ns_DbPoolPutHandle(handle);
      return; 
    }
   
    argv = malloc(sizeof(char*)*3);
    while ((success = Ns_DbGetRow(handle, row)) == NS_OK) {
    argv[1] = Ns_SetGet(row, "j_screen");
    argv[2] = Ns_SetGet(row, "j_passwd");
    JABBER_Register(JABBERConn, argv);
    Ns_Log(Notice, "Registration for user: %s@%s requested", argv[1], JABBER_SERVER);
    } 
      
    Ns_Log(Notice, "Update complete");    
    free(argv);
    Ns_DbPoolPutHandle(handle);
    return;   
    }
  }


*/

char* JABBERgetRegState(char *screen) {
   char* pool;
  char query[200];
  Ns_DbHandle *handle;
  char* status;

  pool = Ns_DbPoolDefault(VIRTUAL_SERVER_NAME);
  if ((handle = Ns_DbPoolGetHandle(pool)) != NULL)
    {Ns_Set *row;
    snprintf(query, 200, "Select state from jabber_users where LOWER(j_screen) = LOWER(%s)", screen);
    row = Ns_Db1Row(handle, query);
    if (!row) {
      Ns_DbPoolPutHandle(handle);
      return(NULL); 
    } 
    status = strdup(Ns_SetGet(row, "j_regstate")); /*free*/
      Ns_SetFree(row);
      Ns_DbPoolPutHandle(handle);
      return (status);
 

      }	 return "1";

  }
 


/*
void JABBERDeleteUser(char *screen)
{
   char* pool;
  Ns_DbHandle *handle;
  char query[200]; 
  int success;
 
   pool = Ns_DbPoolDefault(VIRTUAL_SERVER_NAME);
  if ((handle = Ns_DbPoolGetHandle(pool)) != NULL)
    {snprintf(query , 200,  "delete from jabber_users where j_regstate='u' AND LOWER(j_screen) = LOWER('%s')" , screen); 
      
       success = Ns_DbDML(handle, query); 

       if (success != NS_OK) {
	  debug
	   Ns_Log(Error,"Jabber Database query: '%s' failed", query);
	}
	Ns_DbPoolPutHandle(handle);
        return;   
    } 
  }
*/

int JABBER_Dbml_Main(char *sql )
{  
  /*  Ns_DbHandle *handle;
  int ret;
  char *pool;
  pool = Ns_DbPoolDefault(VIRTUAL_SERVER_NAME);
  handle = Ns_DbPoolGetHandle(pool);
  
  if(handle) 
    {
      ret =  Ns_DbDML(handle, sql);
      Ns_DbPoolPutHandle(handle);
      return ret;
    }
  else {return -1;}
  */ 
 return Jb_DbPipePoolAdd(DbSystemPipe, sql);
   
}


int JABBER_Dbml(char *sql )
{  
  return Jb_DbPipePoolAdd(DbSystemPipe, sql);  
}

int JABBER_Dbml_Direckt(char *sql)
{
  Ns_DbHandle *handle;
  int ret;
  char *pool;
  pool = Ns_DbPoolDefault(VIRTUAL_SERVER_NAME);
  handle = Ns_DbPoolGetHandle(pool);
  
  if(handle) 
    {
      ret =  Ns_DbDML(handle, sql);
      Ns_DbPoolPutHandle(handle);
      return ret;
    }
  else {return -1;}
   

}


int  JABBER_0or1true(char *sql)
{ 
  

  Ns_DbHandle *handle;
  Ns_Set *row;
  char *pool;
  pool = Ns_DbPoolDefault(VIRTUAL_SERVER_NAME);
  handle = Ns_DbPoolGetHandle(pool);
  
  
  if(handle)
    {
      row = Ns_Db1Row((Ns_DbHandle*) handle, sql);
      if(row){
              Ns_SetFree(row);
              Ns_DbPoolPutHandle((Ns_DbHandle*)handle);
              return 1;
             }
      else {
             Ns_DbPoolPutHandle((Ns_DbHandle*)handle);
             return 0;
            }
    } 
  else {return 0;}

} 

int JABBER_Subscription_Check(char* jid)
{ pool p = NULL;
  int exists = 0;
  char* sql = NULL;
  Ns_DbHandle *handle;
  Ns_Set *row;
  handle = Ns_DbPoolGetHandle("jabber");
     
  p = pool_heap(256);
  if(!p)return 0;
  
  sql = pmalloc(p , sizeof(char) * 200);
  if(!sql) return 0;
  
  snprintf(sql, 201 , "select (jb_subscription_check ('%s')) as subs from dual " , jid );

       Ns_Log(Notice ,"Check for subscribing user in the db jid: %s  ", jid); 
           if(handle)
             {	       row = Ns_Db1Row((Ns_DbHandle*) handle, sql);
	       if(row){
		
                   exists = j_atoi( ( (char*)Ns_SetGet(row , "subs") ) , 0);
		  
		  
		 Ns_DbPoolPutHandle((Ns_DbHandle*)handle);
		 
	       }
	       else {
		 Ns_DbPoolPutHandle((Ns_DbHandle*)handle);
		
	       }
	     } 
           else { Ns_Log(Notice , "Recived a Subscribed from some one who is not in the db");} 
                

	   return exists;

}
 



/****************************************************************************************************************
 Pipe Funktions , many dml_statements (update , inserts) kann be stuffed into a Pool (PipePool), another thread *
 that dynamicly starts when the pool is full (or after a pre configured piriod), will stuff everyting from the  *
 Pool into the DB.   (on day we bring the whole pool in once to oracle ,to  proccess it their, to reduce network*
 bandwidth)                                                                                                     *
 ****************************************************************************************************************/



//#include "lib_jclient.h"


int _Jb_DbPipePoolAdd(Jb_DbPipe pipe , char* toadd)
{
  Ns_Log(Notice,"_Jb_PipePoolAdd 1 xml = %s , toadd = %s " , xmlnode2str(pipe->pool) , toadd );
   if( pipe == NULL || pipe->pool == NULL || toadd == NULL)return -1;
 
  xmlnode_insert_tag(pipe->pool , "sql");
  xmlnode_insert_cdata(xmlnode_get_lastchild(pipe->pool) , toadd , -1);
      


  if(   (j_strlen(toadd) + 12 + sizeof(_xmlnode) + pipe->pool->p->heap->used) > pipe->poolsize  )return 1;
     Ns_Log(Notice,"_Jb_PipePoolAdd 3");
   
    xmlnode_insert_tag(pipe->pool ,"sql");
    xmlnode_insert_cdata(xmlnode_get_lastchild(pipe->pool) , toadd , -1);  

  Ns_Log(Notice,"_Jb_PipePoolAdd 3 xml = \n %s" , xmlnode2str(pipe->pool));  
  /*
   Ns_Log(Notice,"_Jb_PipePoolAdd 4");
  for(i = sql_cache->cur_len ; i < (j_strlen(toadd) + 1 + sql_cache->cur_len)
; i++)
    {   Ns_Log(Notice,"_Jb_PipePoolAdd 5 i = %d , i - sql_cache->cur_len = %i " , i,(i - sql_cache->cur_len));
      sql_cache->sql_first[i] = toadd[i - sql_cache->cur_len];
    }
   Ns_Log(Notice,"_Jb_PipePoolAdd 6 sql_cache->sql_first = %s" ,sql_cache->sql_first[ sql_cache->cur_len -i]);
  sql_cache->cur_len = j_strlen(toadd) + 1 + sql_cache->cur_len;

  Ns_Log(Notice , "_Jb_DbPipePoolAdd toadd = %s , sql_cache->first + sql_cache->cur_len = %s , sql_cache->cur_len = %d" ,toadd , (char*)(sql_cache->sql_first + sql_cache->cur_len) , sql_cache->cur_len);
  */
 
 return 0;
 
}


int Jb_DbPipePoolAdd(Jb_DbPipe pipe,  char* toadd)
{ int result = 0;

  if( pipe == NULL || toadd == NULL)return -1;

    Ns_Log(Notice,"Jb_PipePoolAdd pipe == %x , toadd = %s",pipe , toadd  );
   result =  _Jb_DbPipePoolAdd(pipe , toadd);
   
   if( result == 1 )
     { Ns_Log(Error,"Jb_PipePoolAdd 2");
       result = Jb_DbPipeSend(pipe , 1 );
       return _Jb_DbPipePoolAdd(pipe , toadd);
     }
 Ns_Log(Error,"Jb_PipePoolAdd 3");
   return result; 
}



xmlnode Jb_PipePoolNew( Jb_DbPipe pipe , long int size)
{
  pool p = NULL;
  
  xmlnode x = NULL;


  p = pool_heap(size);
  x = xmlnode_new_tag_pool(p , pipe->envelop_name);
  Ns_Log(Notice , "Jb_PipePoolNew  1 , p = %x , x = %x , pipe->envelop_name = %s " , p , x , pipe->envelop_name);  
  
  return x;
 
  /*
  p = pool_heap((sizeof( char ) * size) + 50 + sizeof(_Jb_PipePool));
    
  sqlp = pmalloc(p , sizeof(_Jb_PipePool) );
  sqlp->sql_first = pmalloc(p, sizeof( char ) * size); 
  sqlp->sql_first[0] = 0;
  sqlp->p = p;
  sqlp->len = size;
  sqlp->cur_len = 0;
  

  return sqlp;
  */
}

void _Jb_DbPipeSend(void* arg )
{
  Ns_DbHandle *handle;
  
   char* sql_send = NULL;
   xmlnode  x = NULL;   
   Jb_DbPipe pipe = NULL; 
   int success = 0;
   Ns_Mutex pipemutex;
   Ns_Event pipeevent;    

   Ns_InitializeMutex(&pipemutex);
    Ns_MutexLock(&pipemutex);

      Ns_Log(Notice," DB PipeThread StartsUp");

  if( ( pipe = (Jb_DbPipe)arg) == NULL ) 
    {
      Ns_Log(Notice , "_Jb_PipeSend could not send PipePool to db, reason: empty Data");   
      return;
    }

  pipe->send_event = &pipeevent;

  while(1)
    {

      Ns_InitializeEvent(&pipeevent);       
      Ns_Log(Notice , "DB PipeThread slept in , pipe->thread_end = %d" , pipe->thread_end);
      Ns_WaitForEvent(&pipeevent , &pipemutex );
  
      Ns_Log(Notice , "DB PipeThread woke up , pipe->thread_end =%d"  ,pipe->thread_end);

      if ((handle = Ns_DbPoolGetHandle("jabber")) == NULL)
	{Ns_Log(Notice , "Could not write db_cache to db. cause: no handle");
	xmlnode_free(pipe->send_pool);
	continue;
	}

   
      for (x = xmlnode_get_tag(pipe->send_pool , "sql"); x != NULL ; x = xmlnode_get_nextsibling(xmlnode_get_nextsibling(x))   )
	{
	  sql_send = xmlnode_get_data(x);
	  success = Ns_DbDML(handle , sql_send);
	  Ns_Log(Notice , "sql-xml : \n %s ,\n sql-char : \n %s" , xmlnode2str(x) , sql_send);
	}


      Ns_Log(Notice , "Wrote db_PipePool to db . \n %s" , xmlnode2str(pipe->send_pool));
      xmlnode_free(pipe->send_pool);
      pipe->send_pool = NULL;
      Ns_DbPoolPutHandle(handle);

     if((pipe->thread_end == 127 )){
       Ns_Log(Notice , "DB Pipe Thread exits ,  pipe->thread_end =%d" , pipe->thread_end);
       break;
        // Ns_ThreadExit(0);
         }
    }
  Ns_ThreadExit(0);

}

/**************************************************************
xmlnode pipe_pool = pp , x;

x = xmlnode_get_tag(pp, sql);
char* cache;

for (x = xmlnode_get_tag(pp, sql); x != NULL ; xmlnode_get_nextsibling(xmlnode_get_nextsibling(x));   )
{
  cache = xmlnode_get_data(x);
  if(cache) {
      success = Ns_DbDML(handle , sql_start);
       

  }
  xmlnode_free(x);

}*/

     




/****************************************************************/


int Jb_DbPipeSend(Jb_DbPipe pipe , int force )
{time_t now;
 int dummy = 0;
 xmlnode  send_pool = NULL, cache_pool = NULL;
  
  time(&now);
  //         Ns_Log(Notice," IM Jb_PipePoolSend 1 pipe %x , pipe->pool %x , pipe->lock  %x" , pipe , pipe->pool , pipe->lock);
  if( pipe == NULL || pipe->pool == NULL || pipe->lock == NULL )return -1;
  //     Ns_Log(Notice," IM Jb_PipePoolSend 2");

  if(pipe->nextpush <= now || (force))
    {          Ns_Log(Notice," IM Jb_PipePoolSend 3");
     Ns_MutexLock(pipe->lock);
               Ns_Log(Notice," IM Jb_PipePoolSend 4");
     if (pipe->send_pool){Ns_Log(Error , "Wasn't able to send DB Pool to DB in crease Buffer Size or reduce the time interval !!");}
     pipe->send_pool = pipe->pool;
     dummy = Ns_SetEvent(pipe->send_event);
     Ns_Log(Notice," IM Jb_PipePoolSend 5");
     pipe->pool = Jb_PipePoolNew(pipe , pipe->poolsize );
     Ns_Log(Notice," IM Jb_PipePoolSend 6");
     Ns_MutexUnlock(pipe->lock);
  
     pipe->nextpush = pipe->interval + now;

      //    Ns_ThreadCreate(  _Jb_DbPipeSend , send_pool , 1000 , &pipe_thread);

      return 0;

    }
  // Ns_Log(Notice," IM Jb_PipePoolSend 5");
  return 1;

}



void Jb_DbPipeLoginInit(Jb_DbPipe pipe)
{ time_t now;

  pipe->pool = Jb_PipePoolNew(pipe , pipe->poolsize);
  pipe->send_pool = NULL;
  time(&now);
  pipe->nextpush = pipe->interval + now;   
  pipe->thread_end = 0;
  pipe->send_event = NULL;
  Ns_ThreadCreate(  _Jb_DbPipeSend , pipe , 3000 , &pipe_thread);
  Ns_Log(Notice , "Initialized Pipe Pool for Login next push : %d" , pipe->nextpush); 

}

void Jb_DbPipeLogoutCleanUp(Jb_DbPipe pipe)
{
  if(pipe != NULL)
    {
       pipe->thread_end = 127;
       Ns_SetEvent(pipe->send_event);
    }
}
 
void Jb_DbPipeStartupInit(long int poolsize , time_t interval )
{
  pool p = pool_heap(255);
  Jb_DbPipe pipe = NULL;

  pipe = pmalloc(p , sizeof(_Jb_DbPipe));
  pipe->interval = interval;
  pipe->nextpush = 0;
  pipe->pool = NULL;
  pipe->poolsize = poolsize;
  pipe->lock = pmalloc(p , sizeof(Ns_Mutex));
  pipe->envelop_name = "pipe_pool";
  Ns_MutexInit(pipe->lock);
 
  DbSystemPipe = pipe;
  DbSystemPipePool = p;

  Ns_Log(Notice , "Initialized DbPipe poolsize = %d , interval = %d", poolsize , interval );
  
}









