/* ------------------------------------------------------------------------
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *	
 * 
 *
 *   Copyright Sussdorff & Roy 2001 (www.sussdorff-roy.de)
 *   
 *   Developers: Malte Fliedner  ( maltefliedner@aol.com )
 *               Bjoern Kiesbye  ( xkiesbye@aol.com )       
 * 
 * Acknowledgements
 * 
 * Special thanks to the Jabber Open Source contributors for their
 * suggestions and support of Jabber, and to Malte Sussdorff for his support
 * and for giving us the possibility to work on this project.
 * 
 * This code borrowed heavily from the EVERYBUDDY jabber client of Robert 
 * Lazzurs. Please see http://www.everybuddy.com for further details
 * 
 * --------------------------------------------------------------------------*/
 
   


//#include "ns.h"
//#include "nsd.h"
//#include "nssocket.h"







#include <stdio.h>
//#include <jabber/jabber.h>
#include "../include/jabber/lib_jclient.h"
//#include "ns.h"


extern void JABBERStatusChange(void *data);
extern void JABBERCleanUp();
extern void JABBERDeleteUser(char *screen);
extern void JABBERRegValidation(char *screen, char *value);
extern void JABBERRegUpdate(JABBER_Conn* JABBERConn);

extern char *JABBER_SERVER;
extern char *COMMUNITY_CLIENT; 
extern char *AIM_SERVICE;
extern char *ICQ_SERVICE;
extern char *YAHOO_SERVICE;
extern char *MSN_SERVICE;
extern char *IRC_SERVICE;
extern char *CONFERENCE_SERVICE; 
extern char *CLIENT_PASS_JB;

extern Jb_DbPipe DbSystemPipe;

xmlnode JB_AGENTS;

short int service_online[8]; //we have 6 transports that can be ofline -1 or online 0 , our jabber server and we count from 1 to ..,
                             //for compatibility , reasons with the acs.

acs_x_packet jb_util_acs_x_packet(xmlnode x);


//JABBER_Conn *Connections=NULL;
JABBER_Conn *JABBERConn=NULL;
Ns_RWLock  *JConnLock; 
Ns_Mutex *FDLock;
pool p;
Jb_Ring response_ring;
int UTimeSockRead = 200;

void j_on_state_handler(jconn conn, int state);
void j_on_packet_handler(jconn conn, jpacket packet);

 



JABBER_Conn *jabber_newJConn(void)
{
	JABBER_Conn *jnew=NULL;

	/* Create a new connection struct */ 
	jnew=malloc(sizeof(JABBER_Conn));
	return (jnew);

}

/* checks and returns conection state (either online or offline) */
int JCgetConnState () {
if(!JABBERConn || !JABBERConn->conn || JABBERConn->conn->state !=JCONN_STATE_AUTH)
  {
      return -1;
    } 
 return 0;
}

/* scheduled handler function which checks socket for incoming data  */
//int jabber_callback_handler(SOCKET sock, void* context, int why)

void jabber_callbackHandler(void* context)
{   JABBER_Conn *JConn = context;
    int fork,timeout;
    Ns_Mutex pollmutex;
    Ns_Event pollevent;  

  /* Is this connection still good? */
 Ns_RWLockRdLock(JConn->conn->lock);
 if(!JConn || !JConn->conn)
   {
     Ns_Log(Debug, "Jabber_callbackHandler got passed a NULL pointer");
     Ns_ThreadExit(0);return; 
   }
 Ns_RWLockUnlock(JConn->conn->lock);

  Ns_MutexInit(&pollmutex);
  Ns_InitializeEvent(&pollevent);
 
 while(1)
   { //Ns_Log(Debug, "jabbercallback lock");
     Ns_RWLockRdLock(JConn->conn->lock); 
     if(JConn->conn->state==JCONN_STATE_OFF || JConn->conn->fd==-1)
      { 
        JABBERCleanUp();
        JConn->threadr = NULL;  
        Ns_RWLockUnlock(JConn->conn->lock);
        Jb_DbPipeLogoutCleanUp(DbSystemPipe);
        Ns_Log(Notice , "jabber logout no connection");
        Ns_ThreadExit(0);
        return;
      }    
    
      jab_poll(JConn->conn, 0); //check the socket to jabber for incomming xml-documents 

      //Ns_Log(Notice," for Jb_PipePoolSend ");
      Jb_DbPipeSend(DbSystemPipe , 0 ); //check if the times up to move the db_buffer to the db
      // Ns_Log(Notice," Nach Jb_PipePoolSend ");
      Ns_RWLockUnlock(JConn->conn->lock);
      Ns_MutexLock(&pollmutex);
      timeout =  Ns_UTimedWaitForEvent(&pollevent , &pollmutex , 0 , UTimeSockRead);
      Ns_MutexUnlock(&pollmutex); 

   }
}
  


JABBER_Conn *JABBER_Login(char *handle, char *passwd, char *host, int port) {
	/* At this point, we don't care about host and port */
        int  lID, result;
	pool p;
	jid jid;
	char* cjid;
	//char jid[256+1];
	//char buff[4096];
	JABBER_Conn *JConn=NULL;
	Ns_Log(Debug, "Connecting to Jabber Server...");
	/* make sure that client jid is correct 
	 */
		p = pool_new();
	
		/* parse client's jid form: user@server/resource */
		jid = jid_new(p, handle);
	  
		/* check whether user, server and resource is well defined */
		if(!jid->server || !jid->user || !jid->resource) {
		  Ns_Log(Error, "Invalid Jabber Client name: %s", jid_full(jid));
		  pool_free(p);
		    return(NULL);
		}
		cjid = strdup(jid_full(jid));
		pool_free(p);
	      /*if(!strchr(handle, '@')) {
		     /A host must be specified in the config file /
		if(!host) {
		  / ("No jabber server specified!", "Cannot login");/
			return(NULL);
		}
		snprintf(jid, 256, "%s@%s/ACES", handle, host);
	}
	else if(!strchr(handle, '/'))
		snprintf(jid, 256, "%s/ACES", handle);

	else
		strncpy(jid, handle, 256);
	      */
	if (!JABBERConn) {
	  JConn=jabber_newJConn();
	} else {
	  if(JCgetConnState() == 0) {
	    Ns_Log(Debug, "... already connected "); 
	      
	    return (JABBERConn);
	  } 
          else { 
	        /*we are reconnecting no need to set up everything new, 
		  just try to reconnect*/
	          JConn=JABBERConn;
	           jab_start(JConn->conn);
                    if(JConn->conn->state == JCONN_STATE_OFF ) {return JConn;}
		    //we are connected
                  Ns_ThreadCreate(jabber_callbackHandler , JConn , 200000 ,JConn->threadr);
                   jab_auth(JConn->conn);
                    p = pool_new();
                     JConn->loginevent = pmalloc(p, sizeof(Ns_Event));
                      Ns_InitializeEvent(JConn->loginevent);
                       Ns_MutexLock(&JConn->loginlock);
                        Ns_RWLockUnlock(JConn->conn->lock);
                         result = Ns_TimedWaitForEvent(JConn->loginevent , &JConn->loginlock , 20);
			  //We timed out or we are autherized
                           Ns_MutexUnlock(&JConn->loginlock);
                            Ns_RWLockWrLock(JConn->conn->lock);
                             pool_free(p);
                              JConn->loginevent = NULL;
      
 
                         if(result == NS_TIMEOUT) 
                           {Ns_Log(Debug, "Jabber: Login Timedout after 20 sec.");
                             jab_stop(JConn->conn);
                              return JConn;
                           }
	                 else if(result != NS_OK)
                           {Ns_Log(Error, "Jabber: unreconized error during Login");
	                     jab_stop(JConn->conn);
                              return JConn;
                           }
	                 else 
                           {JConn->conn->state = JCONN_STATE_AUTH; 
                             Ns_Log(Debug, "Jabber server responding. Auth sucssesfull!");
	                      return JConn;
                           }
                  /* For a more detailed description of authing,
                     read comments a few lines further down*/
                     
               }
	}
	Ns_Log(Debug, "Logging in with jid: %s", cjid);
	JConn->jid = cjid; 
	Ns_Log(Debug, "creating new jconn");	
	/* creating new jconn object */
	JConn->conn=jab_new(cjid, passwd);
	Ns_Log(Debug, "new jconn created");

	if(!JConn->conn) {
	  /* didn't work, so end */    
		Ns_Log(Error, "Unable to create Jabber Connection Object. Login failed!");
		//Ns_Log(Debug, "free");
		//free(JConn);
		//JConn=NULL;
		return(NULL);
	}
	
	/* setting handler functions to jconn object */
	
	jab_packet_handler(JConn->conn, j_on_packet_handler);
	jab_state_handler(JConn->conn, j_on_state_handler);
	
	/*asign sync locks to connection*/
	JConn->conn->lock = JConnLock;
        JConn->conn->wlock = FDLock;
        Ns_Log(Debug, "locks set"); 

        /* start connection */
	jab_start(JConn->conn);
	if(!JConn->conn || JConn->conn->state==JCONN_STATE_OFF) {
		
		Ns_Log(Error, "Jabber server not responding. Login failed jconn=%x",JConn->conn);
                 
		jab_stop(JConn->conn);
		Ns_Log(Error, "Jabber server not responding. jab_stop ausgefuehrt");
                //JConn->conn=NULL; 
		//JConn=NULL;
		return(NULL);
	}
	
       
	// Ns_Log(Debug, "pre auth");
	
        //Start a thread that reads from our conection.

        JConn->threadr = NULL; 
        Ns_ThreadCreate(jabber_callbackHandler , JConn , 200000 ,JConn->threadr);
 
   //Initialyse objects to let this tread wait for a auth response from jabber
        p = pool_new();
        JConn->loginevent = pmalloc(p, sizeof(Ns_Event));
        Ns_MutexInit(&JConn->loginlock);
        Ns_InitializeEvent(JConn->loginevent);
        Ns_MutexLock(&JConn->loginlock);
        
        JABBERConn = JConn;  //we do this in tcl_j.. too, but we need it here
	                     //because of the j_on_packet_handler that access
	                     //JABBERConn->loginevent,when it recived auth date 
        jab_auth(JConn->conn); //now send auth request to JServer 
        
     //releas the writelock so the system thread can read from the connection 
     //getConnState still returns faules.
        Ns_RWLockUnlock(JConn->conn->lock); 

     //now wait for a response , or a timeout
        result = Ns_TimedWaitForEvent(JConn->loginevent , &JConn->loginlock , 20);
        Ns_Log(Error, "Jabber: nach dem event, result = %d.",result);
   //JServer responding un/succesfull ? or a timeout ? or an error ?
   //First require a write lock , we are going to change our Sate.And cleanup. 
        Ns_MutexUnlock(&JConn->loginlock);  
        Ns_RWLockWrLock(JConn->conn->lock);
        pool_free(p);
        JConn->loginevent = NULL;
      
 
         if(result == NS_TIMEOUT) 
           {Ns_Log(Debug, "Jabber: Login Timedout after 20 sec.");
             jab_stop(JConn->conn);
               return JConn;
           }
	 else if(result != NS_OK)
           { Ns_Log(Error, "Jabber: unreconized error during Login");
	      jab_stop(JConn->conn);
               return JConn;
           }
	 else 
           { JConn->conn->state = JCONN_STATE_AUTH; 
              Ns_Log(Debug, "Jabber server responding. Auth sucssesfull!");
	   } 
	
	/* setting aol server schedule proc to check socket for incoming data.
	   NOTE: Ns_Sock functions could cause problems, when new socket has to           be created at server runtime */
	//lID = Ns_SockCallback(JConn->conn->fd, jabber_callback_handler, JConn, NS_SOCK_READ);
	
	//lID = Ns_ScheduleProc(jabber_callbackHandler, JConn, 0, 1);
        /* listener ID to unschedule procedure */
	/* we use a thread now, gets more time slices than a 
           Ns_ScheduleProc */
      
	
	
       //JConn->listenerID = lID;
	
	/* id to verify packet (not needed?) */
	
	JConn->id = 1;
	
	/* flag to track registration (not needed?)*/
	
	JConn->reg_flag = 0;
        
	/* check for queueing (un)registration requests of JABBER Users
	   FIXME: Can't be sent now. Client needs to be authorized first! */ 
	 
	//JABBERRegUpdate(JConn); 
	Ns_Log(Debug, "Connection successful");
	return(JConn);

}



void JABBER_AfterLogin(JABBER_Conn *JConn ) 
{
   xmlnode x;
   int ret;
   void* *resp;
   resp = pmalloc(p,sizeof(void*)); 
   //jb_sleep(10);
   x = jutil_iqnew( JPACKET__GET , "jabber:iq:agents");
   ret = Jb_Send_Wait_For_Response(JConn->conn , 10 , x ,resp ,NULL);
   if(ret == NS_OK){
       JB_AGENTS  = (xmlnode) resp[0];
       xmlnode_free(x);
                   }
   /*
  x =  jutil_iqnew( JPACKET__GET , "jabber:iq:roster");
  ret = Jb_Send_Wait_For_Response(JConn->conn , 10 , x ,resp, NULL);
    if(ret == NS_OK) {
          xmlnode cur = NULL;
      jid id = NULL;
      pool p = pool_new();
      xmlnode_free(x);
      int count = 0 , timeout = 0;
      Ns_Mutex probemutex;
      Ns_Event probeevent;
 
      Ns_MutexInit(&probemutex);
      Ns_InitializeEvent(&probeevent);
 
     
      x = resp[0];
      for(cur = xmlnode_get_tag(xmlnode_get_tag( x , "query" ) , "item") ; cur != NULL ; cur = xmlnode_get_nextsibling(xmlnode_get_nextsibling(cur)) )
	{
	  Ns_Log(Debug ,"probing item : %s" , xmlnode2str(cur));
           id = jid_new( p , xmlnode_get_attrib( cur , "jid") );
	   if(j_strcmp(id->server , JABBER_SERVER) == 0 && jid_full(id) != NULL)
             {
               x = jutil_presnew(JPACKET__PROBE , jid_full(id) , NULL);
               xmlnode_put_attrib( x , "from" , COMMUNITY_CLIENT);
	       jab_send(JConn->conn , x);
               Ns_Log(Debug , "Probing xml : \n%s" , xmlnode2str(x));
               count++;
               xmlnode_free(x);
              
	       if(count == 2)
		 {
		   Ns_MutexLock(&probemutex);
		   timeout =  Ns_UTimedWaitForEvent(&probeevent , &probemutex , 0 , 400);
		   Ns_MutexUnlock(&probemutex); 
                   count = 0;
		 }


             }
	     }  no probing 

     xmlnode_free((xmlnode) resp[0]);
                   }
   */
    Jb_Sleep(10);
  x = jutil_presnew(JPACKET__AVAILABLE , NULL , NULL);
  jab_send(JConn->conn , x);
  Jb_Sleep(10);
                        
}

int JABBER_SendMessage(JABBER_Conn *JConn, char *handle, char *message) {
	xmlnode x;
        char jid[256+1]; 

	if(!JConn || !JConn->conn) {
	       return(-1);
	}
	if(!strchr(handle, '@')) { 
		snprintf(jid, 256, "%s@%s", handle, JABBER_SERVER);
	} else {
	        strncpy(jid, handle, 256);
	}  
	  
	x = jutil_msgnew(TMSG_CHAT, jid, NULL, message);
	jab_send(JConn->conn, x);
	return(0);
}

int JABBER_Logout(JABBER_Conn *JConn) {
  xmlnode x;
   
  Ns_Log(Debug, "Logging out from Jabber Server ...");
  if(!JConn || !JConn->conn) {
	  Ns_Log(Debug, "unable to log out Jabber Server: No Connection");
	
	return(-1);
  }
  /*else if(!JConn->conn) {
	  Ns_Log(Debug, "unable to log out Jabber Server: No Connection");
	  //Ns_Log(Debug, "free");
	  //free(JConn);
	  //JConn=NULL;
	  return(-1);
  }*/
   else if (JConn->conn->state == JCONN_STATE_OFF){
	  Ns_Log(Debug, "unable to log out Jabber Server: No Connection");
	  return(-1); 
   }
         
   /* JConn->conn exists, closing everything up */
    
    x = jutil_presnew(JPACKET__UNAVAILABLE, NULL, NULL);
    jab_send(JConn->conn, x);
    jab_stop(JConn->conn);
    JABBERCleanUp();
    //Jb_DbPipeLogoutCleanUp(DbSystemPipe);
    Ns_Log(Debug, "Logged out");
    return(0);   
	  
          
		    /*JABBERCleanUp();
	Ns_Log(Debug, "Logged out");
	return(0); */
}


int JABBER_ChangeState(JABBER_Conn *JConn, int state) {
	xmlnode x,y;
	
	char show[7]="", *status="";

	if(!JConn || !JConn->conn)
	    return(-1);
	
	x = jutil_presnew (JPACKET__UNKNOWN, NULL, NULL);

	if (state != JABBER_ONLINE) {   
		y = xmlnode_insert_tag (x, "show");
		switch (state) {
		case JABBER_AWAY:
			strcpy (show, "away");
			break;
		case JABBER_DND:
			strcpy (show, "dnd");
			break;
		case JABBER_XA:
			strcpy (show, "xa");
			break;
		case JABBER_CHAT:
			strcpy (show, "chat");
			break;
		default:
			strcpy (show, "unknown");
			Ns_Log(Debug, "Unknown Jabber state suggested: %i ", state);
			}
		xmlnode_insert_cdata (y, show, -1);
	} else {
	  status="Online";
	}
	if (strlen (status) > 0) {
		y = xmlnode_insert_tag (x, "status");
		xmlnode_insert_cdata (y, status, -1);
	}
	 Ns_Log(Debug, "Setting Jabber client status to: %s - %s", show, status);
	jab_send (JConn->conn, x);
	return(0);
}

/* ----------------------------------------------*/


/* Functions to handle jabber responses */

void j_on_packet_handler(jconn conn, jpacket packet) {
	jid jabberid;
        xmlnode x, y, z;
	char *id, *ns, *sub, *name, *from , *resource, *group;
	char *desc, *service, *to, *url;
	char *show, *type, *body, *subj, *ask, *code;
	//char buff[8192+1];	/* FIXME: Find right size */
	int iid, status;
        Jb_Ring_Item resp;
	pool p;
	
	JABBER_Conn *JConn=NULL;
	/* removed struct */
	//jabber_buddy JB;
	
	
	//JConn=JCfindConn(conn);
	JConn=JABBERConn;
	jpacket_reset(packet);
	Ns_Log(Debug, "Jabber Packet: %s received,type %d, XML: %s", packet->x->name,packet->type, xmlnode2str(packet->x));
	
	/* determine the type of the packet */ 
	switch(packet->type) {
	char* jid;
	acs_x_packet apacket;
	case JPACKET_MESSAGE:
	Ns_Log(Debug, "Jabber MSG Packet: %s received", packet->x->name);
        p = pool_heap(150);
        jabberid = jid_new(p,xmlnode_get_attrib(packet->x, "from"));
        if(j_strcmp(jabberid->server , CONFERENCE_SERVICE) == 0)
	{ Jb_ConferenceMessages(packet);
	  pool_free(p);
          xmlnode_free(packet->x);
          break;
        }
        else {pool_free(p);}
        
        if( j_strcmp ( xmlnode_get_attrib(xmlnode_get_tag(packet->x , "x") , "xmlns") , "jabber:x:conference") == 0 )
	  {
            Ns_Log(Debug, "Jabber Packet: Im j_on_packethandler Invite XML: %s", xmlnode2str(packet->x));
            Ns_ThreadCreate(Jb_ReciveInviteV1 , packet->x , 4096 , NULL);
            break; 

	  }
 
	if (!(y = xmlnode_get_tag(packet->x , "x")) || !(j_strcmp(xmlnode_get_attrib(y,"xmlns"), "jabber:x:acs" ) == 0) || xmlnode_get_attrib(xmlnode_get_tag(y,"jadmin"),"agent")[0]!= AGENT_CLIENT) {break;}  
	 
         
         
         apacket = jb_util_acs_x_packet(y);
	 
	
	 if (apacket->type == JB_REGISTER) {
  	    int id;
            char* cx = xmlnode_get_attrib(xmlnode_get_tag(apacket->x , "jadmin") , "id");
            if ( (id  = j_atoi(cx,0 )) ) 
             {   
              resp = Jb_Ring_GetRemItem(&id , response_ring); 
              // p = pool_new();
              //jabberid = jid_new(p,xmlnode_get_attrib(apacket->first,"jid")); 
	      // if(jabberid->user)
	      //   {
	      //  if(!j_strcmp(xmlnode_get_attrib(apacket->first,"success"),"r"))
	      //    { JABBERRegValidation(jabberid->user, "r");}
	      //   }
	      // pool_free(p);
	      //  }

             if(resp)
               {resp->object = apacket->first;
                Ns_SetEvent(resp->notifie); 
	       } 
	    else 
	      { p = pool_new();
                jabberid = jid_new(p,xmlnode_get_attrib(apacket->first,"jid")); 
                if(jabberid->user)
		  {
                 if(!j_strcmp(xmlnode_get_attrib(apacket->first,"success"),"r"))
		   { JABBERRegValidation(jabberid->user, "r");}
                 else if(!j_strcmp(xmlnode_get_attrib(apacket->first,"success"),"e")) 
		   { /*JABBERDeleteUser(jabberid->user);*/}
	       	 else 
		 { Ns_Log(Debug, "Unrecognized Register state for %s recived",jabberid->user); }
                 pool_free(p);
                 }
	       
              }
	     }
	 }
	       
           pool_free(apacket->p);
	break;

	case JPACKET_IQ:
	  /*in case of a conference packet.*/
	  {  pool p ;
	   
	    p = pool_heap(255);
          Ns_Log(Debug, "Jabber Packet: Im j_on_packethandler Iq XML: %s", xmlnode2str(packet->x));
          if( (jabberid = jid_new(p,xmlnode_get_attrib(packet->x , "from")) ))
	    { if(j_strcmp( jabberid->server , CONFERENCE_SERVICE ) == 0)
               Jb_ConferenceIq(packet);
            } 
         
	  if(xmlnode_get_tag(packet->x , "conference") != NULL ) Jb_ConferenceIq(packet);
     
	  pool_free(p);
     	  }


	  /* in case of an error do log entry */
	   if(!j_strcmp(xmlnode_get_attrib(packet->x,"type"), "error")) {
	     char* cid;
             if((cid = xmlnode_get_attrib(packet->x , "id")))
               {int id; 
               if((id = atoi(cid)))
                 {resp = Jb_Ring_GetRemItem(&id , response_ring);
		 if(resp)
                   {resp->object = packet->x;
		    Ns_SetEvent(resp->notifie);
                    break;
                   }
                 }
               }
                 
                x = xmlnode_get_tag (packet->x, "error");
	       	code = xmlnode_get_attrib (x, "code");
	       	desc = xmlnode_get_tag_data(packet->x, "error");
	        xmlnode_free(packet->x); 	
		}
         

	   else if(!j_strcmp(xmlnode_get_attrib(packet->x,"type"), "result"))
	        {char* cid;
                 if((cid = xmlnode_get_attrib(packet->x , "id")))
                   {int id; 
                   if((id = j_atoi(cid,0)))
                     {resp = Jb_Ring_GetRemItem(&id , response_ring);
		     if(resp)
                       {resp->object = packet->x;
		        Ns_SetEvent(resp->notifie);
                        break;
                       }
                     }
                   }
                
                
            
                 if(!j_strcmp(xmlnode_get_attrib(packet->x, "id"), "290auth"))
	           { int value;
               //recived a succesful auth response , notify the waiting thread
                 
                     if(JABBERConn->loginevent)
                        value = Ns_SetEvent(JABBERConn->loginevent); 
                   
                        xmlnode_free(packet->x);  
                   }
	        }	
	   
          break;

	case JPACKET_PRESENCE: 
	  {
	        /* in case of a presence packet get sender data */ 
	        char *ring_cid;
                int ring_id;
                jabber_buddy JB;
                pool bp = pool_new();
                JB = pmalloc(bp,sizeof(_jabber_buddy));
                JB->p = bp;
                status = JABBER_ONLINE;
		from = NULL;
                type = xmlnode_get_attrib (packet->x, "type");
		from = xmlnode_get_attrib (packet->x, "from");


		//check if we have a thread waiting for this id
		if ( (ring_cid = xmlnode_get_attrib(packet->x , id )) )
                  {ring_id = j_atoi(ring_cid,0);
		   resp = Jb_Ring_GetRemItem(&ring_id , response_ring);
		   if(resp)
        	     {
                      resp->object = xmlnode_dup(packet->x);
		      Ns_SetEvent(resp->notifie);
                      
                     }
                  }
                
		//special case a subscription request
                if(   ((!type) && (from)) || j_strcmp(type , "subscribe" ) || j_strcmp(type , "subscribed" ) ) 
		  {       p = pool_new();
	                  jabberid = jid_new(p,from);
                          Jb_PresenceUnOrSubscribed(conn, jabberid);  
                          pool_free(p);
                        /* check in db_ if we wait for a subscribed */ 
		  }//end of if block
  
                      
                p = pool_new();
	
		/* parse jid form: user@server/resource */
		jabberid = jid_new(p, from);
				  
		//resource=strdup(from);
		//JB.resrc=strchr(resource,'/');
                 
		
				
		/* check whether user and server is defined */
		if(!jabberid->server) {
		  pool_free(JB->p);
                  pool_free(p);
                  xmlnode_free(packet->x);
		    break;
		} 
 		

		/*See if we have a Presence for a Conference Room*/
                if(j_strcmp(jabberid->server , CONFERENCE_SERVICE) == 0)
		{                           Ns_Log(Debug , "Presence Room VOR jb_conferenceclient");
		    Jb_ConferencePresence(packet);
                        Ns_Log(Debug , "Presence Room NACH jb_conferenceclient");
                    xmlnode_free(packet->x);
                    break;  
		}
		



		//check if a transport wants  us to know about his state
               if(!jabberid->user){
		 char* state;
                 state = xmlnode_get_data(xmlnode_get_tag(packet->x , "status"));
                
                  if (j_strcmp(jabberid->server, AIM_SERVICE) == 0){
		     if(j_strcmp(state , AIM_ONLINE) == 0) {service_online[JB_AIM] = 0;}  
		     else if(j_strcmp(state , AIM_OFFLINE) == 0 ) {service_online[JB_AIM] =0;}  
		} else if (j_strcmp(jabberid->server, YAHOO_SERVICE) == 0){
		    if(j_strcmp(state , YAHOO_ONLINE) == 0) {service_online[JB_YAHOO] = 0;}  
		     else if(j_strcmp(state , YAHOO_OFFLINE) == 0 ) {service_online[JB_YAHOO] =0;}
		}  else if (j_strcmp(jabberid->server, MSN_SERVICE) == 0){
		    if(j_strcmp(state , MSN_ONLINE) == 0) {service_online[JB_MSN] = 0;}  
		     else if(j_strcmp(state , MSN_OFFLINE) == 0 ) {service_online[JB_MSN] =0;}
		}  else if (j_strcmp(jabberid->server, ICQ_SERVICE) == 0){
		    if(j_strcmp(state , MSN_ONLINE) == 0) {service_online[JB_ICQ] = 0;}  
		     else if(j_strcmp(state , MSN_OFFLINE) == 0 ) {service_online[JB_ICQ] =0;}
		}  else if (j_strcmp(jabberid->server, IRC_SERVICE) == 0){
		    if(j_strcmp(state ,IRC_ONLINE) == 0) {service_online[JB_IRC] = 0;}  
		     else if(j_strcmp(state , IRC_OFFLINE) == 0 ) {service_online[JB_IRC] =0;}
		}  else if (j_strcmp(jabberid->server, CONFERENCE_SERVICE) == 0){
		    if(j_strcmp(state , CONFERENCE_ONLINE) == 0) {service_online[JB_CONFERENCE] = 0;}  
		     else if(j_strcmp(state , CONFERENCE_OFFLINE) == 0 ) {service_online[JB_CONFERENCE] =0;}
		}  else {
		  /* user not local! should not be in client roster */
                  Ns_Log(Debug, "Received presence from external Jabber Transport user: %s , local Server:%s , externalserver:%s", jid_full(jabberid), JABBER_SERVER, jabberid->server);
		        }
                  pool_free(p);
                  pool_free(JB->p);
                  xmlnode_free(packet->x);
                  break;		  
		
	       }

		                    
		/* check whether the user is registered with local jabber server or using a service
		 */
		if (j_strcmp(jabberid->server, JABBER_SERVER) == 0) {
		    JB->service = DB_JABBER;
		} else if (j_strcmp(jabberid->server, AIM_SERVICE) == 0){
		    JB->service = DB_AIM; 
		} else if (j_strcmp(jabberid->server, YAHOO_SERVICE) == 0){
		    JB->service = DB_YAHOO;
		}  else if (j_strcmp(jabberid->server, MSN_SERVICE) == 0){
		    JB->service = DB_MSN;
		}   else if (j_strcmp(jabberid->server, ICQ_SERVICE) == 0){
		    JB->service = DB_ICQ;  
		}    else if (j_strcmp(jabberid->server, IRC_SERVICE) == 0){
		    JB->service = DB_IRC;
		}   else if (j_strcmp(jabberid->server, CONFERENCE_SERVICE) == 0){
		    JB->service = DB_CONFERENCE;
		}  else {
		  /* user not local! should not be in client roster */
                  Ns_Log(Debug, "Received presence from external Jabber user: %s , local Server:%s , externalserver:%s", jid_full(jabberid), JABBER_SERVER, jabberid->server);
		  pool_free(p);
                  pool_free(JB->p);
                  xmlnode_free(packet->x);
		  break;
		}
		
		/* presence packet is o.k., so proceed */
		if(!jabberid->resource){		
		     JB->resrc="unknown";
		  } else {
		     JB->resrc=pstrdup(JB->p,jabberid->resource);
		  
		  }  
		
		//JB.jid=strtok(from, "/");
		//if ther is no user it might be a transport.

		 JB->jid = ( (JB->jid = pstrdup(JB->p,jabberid->user)) ? JB->jid : pstrdup(JB->p,jabberid->server) );
		  pool_free(p);	
		  
		  x = xmlnode_get_tag (packet->x, "show");
		  if (x) {
			show = xmlnode_get_data (x);
			
			if (j_strcmp (show, "away") == 0) status = JABBER_AWAY;
			else if (j_strcmp (show, "dnd") == 0) status = JABBER_DND;
			else if (j_strcmp (show, "xa") == 0) status = JABBER_XA;
			else if (j_strcmp (show, "chat") == 0) status = JABBER_CHAT;
		   
		  }
		  if (type) {
			if (j_strcmp (type, "unavailable") == 0) status = JABBER_OFFLINE;
                        if (j_strcmp (type, "subscribe") == 0) {
                                                                Jb_PresenceUnOrSubscribed(conn ,jabberid);
	                                        		pool_free(p);
                                                                pool_free(JB->p);
								xmlnode_free(packet->x);
			                                        break;
			                                       }
		  }
		  
		  JB->status=status;
		  //JB.JConn=JConn;

		  
		  JABBERStatusChange(JB);
		  xmlnode_free(packet->x);
	  } 
               break;
                
	case JPACKET_S10N:
	  xmlnode_free(packet->x);
              break;
	default:
		Ns_Log(Error, "Unrecognized Jabber packet: %i received", packet->type);
		break;
		
	 }
    
	//xmlnode_free(packet->x); we have to free it idividualy,maybe we have
                                 //to pass the xmlnode back;
	//pool_free(packet->p); darf nicht gefreed werden

}

void j_on_state_handler(jconn conn, int state) {
	static int previous_state=JCONN_STATE_OFF;
	JABBER_Conn *JConn=NULL;
	//char buff[4096];
	/* removed struct */
	jabber_buddy JB;
	pool p;
	jid jabberid;

	/* client enters a new state. create corresponding log entry */
	
	//JConn=JCfindConn(conn);
	JConn=JABBERConn;
	switch(state) {
	case JCONN_STATE_OFF:
	    /*if(previous_state!=JCONN_STATE_OFF) {
			
		  Ns_UnscheduleProc(JConn->listenerID);
			if (JConn->conn) {
				  jab_delete(JConn->conn);
			          JConn->conn=NULL;
			}
			JABBERCleanUp();
			//Ns_Log(Debug, "free");
			//free(JConn);
			//JConn=NULL;*/
			Ns_Log(Debug, "Jabber Server has aborted connection");
			//}
		break;
	case JCONN_STATE_CONNECTED:
	  Ns_Log(Debug, "Jabber client changed state to: CONNECTED");
		break;
	case JCONN_STATE_AUTH:
	  Ns_Log(Debug, "Jabber client changed state to: AUTH");
		break;
	case JCONN_STATE_ON:
	  
	  Ns_Log(Debug, "Jabber client changed state to: ONLINE");
	  p= pool_new();
	  
	  /* add client to online users table */
	  jabberid=jid_new(p, COMMUNITY_CLIENT); 
	    Ns_Log(Debug, "resource:%s, jid:%s",jabberid->resource,jabberid->user);
	  JB->resrc=strdup(jabberid->resource);
	  JB->jid=strdup(jabberid->user);
	  JB->status=JABBER_ONLINE;
	  //JB.JConn=JConn;
	   Ns_Log(Debug, "resource:%s, jid:%s, status:%s",JB->resrc,JB->jid,JB->status);
	  JABBERStatusChange(&JB);
	  pool_free(p);
	        break;
	default:
	  Ns_Log(Debug, "UNKNOWN state for Jabber client: %i", state);
	  break; 
	}
	previous_state=state;
}




void Jb_PresenceUnOrSubscribed(jconn conn ,jid id)
{ char sql[500];
  int true;
  xmlnode x;

  //  snprintf(sql, 501 , "select (jb_subscription_check ('%s')) as exists from dual " , jid_full(id) );

  
  true = JABBER_Subscription_Check(jid_full(id));

 if (true ) {
              
              jab_send(conn , x = jutil_presnew(JPACKET__SUBSCRIBED , jid_full(id) , NULL) ); 
	      snprintf(sql , 501 ,"delete from jabber_trace_reg where lower(user) = lower('%s') and lower(trans_url) = lower('%s')" , id->user , id->server );
              //true = JABBER_Dbml(sql);
           
             }

 //jab_send(conn , x = jutil_presnew(JPACKET__UNSUBSCRIBE , jid_full(id) , NULL) ); 
 
}



charlist  jb_listtochar(char * argv,pool p)
{

  int n=0,i;
  char *handle, *start;
  charlist list;
  list = pmalloc(p,sizeof(_charlist));
  list->p = p;
  list->len = 0;
  
  if(argv == NULL || (*argv == '\0') ) {return list;}
   
  for(handle = argv; handle != NULL;handle = strstr(handle, " "))
    {n++;++handle;} 
  
     list->item = pmalloc(p,sizeof(char*) * ++ n);
     n=0;
     
      
for(handle =strstr((start=argv)," "); handle != NULL; handle = strstr((start=handle), " "))
    { *handle = '\0'; 
      list->item[n++]=pstrdup(p,start);
      *(handle++) = ' ';
    }
 list->item[n++] = pstrdup(p,start);
 
  list->len = n;
  
 return list;

}


int Jb_Send_Wait_For_Response(jconn conn , int sec , xmlnode x , void* *response , char* cid)
{ Ns_Event ev;
  Ns_Mutex lock;
  xmlnode y;
  char* charid;
  Jb_Ring_Item resp;
  pool p = pool_new();
  int result, intid;
  intid = Ns_GetThreadId();
  charid = pmalloc(p,11);
  
  snprintf(charid , 12 , "%d" , intid);

  if( (y=xmlnode_get_tag(x, "x")) != NULL && !j_strcmp(xmlnode_get_attrib(y , "xmlns") , "jabber:x:acs")) 
    { xmlnode_put_attrib( xmlnode_get_tag(y,"jadmin") , "id" ,charid); }
  else
    { xmlnode_put_attrib(x , "id" , charid ) ; }

  //Init everything
  Ns_MutexInit(&lock);
  Ns_InitializeEvent(&ev);
  resp = pmalloc(p , sizeof(_Jb_Ring_Item));
  resp->notifie = &ev;
  resp->id = &intid;
  resp->cid = cid;
  resp->object = NULL;
  
  //Insert our Jb_Ring_item into the response Ring
  Jb_Ring_InsertItem(response_ring , resp);
  Ns_Log(Debug, "Jb_send_wait_for_response sendxml:\n%s \nid=",xmlnode2str(x),intid);
  
  jab_send(conn , x);
  
  result = Ns_TimedWaitForEvent(&ev , &lock , sec ); 
    
     if(result == NS_TIMEOUT) 
       {  
         resp = Jb_Ring_GetRemItem(&intid , response_ring);
	  pool_free(p);
           return result;
       }    
     else if(result != NS_OK)
       { 
	  resp = Jb_Ring_GetRemItem(&intid , response_ring);
           pool_free(p);
            return result;
        }
      else 
        {  Ns_Log(Debug, "response from jserverin send_wait xml=%s",xmlnode2str(resp->object));
           response[0] = resp->object;
	    Ns_Log(Debug, "response from jserverin send_wait xml=%s",xmlnode2str((xmlnode)response[0]));
            return result;
        } 
	
}  

int charcheck(char* strg)
{char *str;
       /* check for low and invalid ascii characters in the username */
    if(strg != NULL)
        for(str = strg; *str != '\0'; str++)
            if(*str <= 32 || *str == ':' || *str == '@' || *str == '<' || *str == '>' || *str == '\'' || *str == '"' || *str == '&') return 1;

    return 0;
}


Jb_Ring Jb_Ring_Init()
{pool p = pool_new();
 Jb_Ring ring = pmalloc(p,sizeof(_Jb_Ring));
 Jb_Ring_Item item = pmalloc(p,sizeof(_Jb_Ring_Item));
 
 ring->p = p;
 ring->first = item;
 ring->last  = item;
  
 item->next = NULL;
 item->back = NULL;
 item->id   = pmalloco(p,sizeof(int));
 item->object = NULL;
    Ns_Log(Debug, "RING init item.id:%d" , item->id);
 Ns_MutexInit(&ring->lock);
 return ring;
}           

void  Jb_Ring_InsertItem(Jb_Ring ring,Jb_Ring_Item item)
 { 
  Ns_MutexLock(&ring->lock);   
  item->back = ring->last;
  item->back->next = item;
  item->next = NULL;
  ring->last = item;
  Ns_MutexUnlock(&ring->lock);
  return;
 }
   
Jb_Ring_Item Jb_Ring_GetRemItem(int *id , Jb_Ring ring)
 { 
   Jb_Ring_Item item = NULL;
   
   Ns_MutexLock(&ring->lock); 



   for(item =ring->first;item !=NULL ; item = item->next)
     {
        if(*(item->id) == *id)break;
     }


     if(item){
              item->back->next = item->next;
              if(item->next){item->next->back = item->back;}
              else {ring->last = item->back;} 
             }

   Ns_MutexUnlock(&ring->lock);

   return item;
 }

Jb_Ring_Item Jb_Ring_GetRemItem_cid(char *id , Jb_Ring ring)
 { 
   Jb_Ring_Item item = NULL;
   
   Ns_MutexLock(&ring->lock); 



   for(item =ring->first;item !=NULL ; item = item->next)
     {
        if(j_strcmp(item->cid, id) == 0 )break;
     }


     if(item){
              item->back->next = item->next;
              if(item->next){item->next->back = item->back;}
              else {ring->last = item->back;} 
             }

   Ns_MutexUnlock(&ring->lock);

   return item;
 }
  


int Jb_LoginMain()
{int ret;

    Jb_DbPipeLoginInit(DbSystemPipe); 
 Ns_RWLockWrLock(JConnLock);
   Ns_Log(Debug, "JConn wurde gelocked","X");
    if(JCgetConnState() == 0) { Ns_RWLockUnlock(JConnLock); return 1;}
     JABBERConn = JABBER_Login(COMMUNITY_CLIENT, CLIENT_PASS_JB, "",0);

     Ns_RWLockUnlock(JConnLock);
     Ns_RWLockRdLock(JConnLock);  

     if(JABBERConn == NULL || JCgetConnState() != 0 /*JABBERConn->conn->state == JCONN_STATE_OFF*/) {
    ret = -1;
    
  } else {


    Ns_RWLockUnlock(JConnLock);
    Ns_RWLockRdLock(JConnLock);
        Jb_DbPipeLoginInit(DbSystemPipe); 
    JABBER_AfterLogin(JABBERConn);
    ret = 0;
  }

  Ns_RWLockUnlock(JConnLock);
  Ns_Log(Debug, "JConn wurde ungelocked","X");
  //Unlock the Jconn object after function returned
 
  return ret;
  
}


void Jb_Startup(void* arg)
{ int trys = 1;
  int start,i;
  Ns_DbHandle *handle;

  start = Ns_WaitForStartup();
  //clean up our online table jb_screen_names
  JABBERCleanUp();
  //Initialaize our conference mod
  Jb_ConferenceInit();

  //set our array for the services to offline;
  for(i = 0 ; i<8 ; i++) service_online[i] = -1;
 
  // now try to login
 
  while(trys <=20)
    {
      if(Jb_LoginMain() == 0 ) {Ns_Log(Debug , "Jabber Client Loged in after %d trys." , trys); break;}
      trys++;             
     }

  if(JCgetConnState() != 0){ Ns_Log(Debug , "Jabber Client couldn't login after %d trys." , trys); return;}

  //we are loged in so we can send all data wich couldn't be send while the client was offline.    
  //wait some time for the transports to get online.
  for(i = 0; i<3 ; i++)
    { 
     Jb_Sleep(10);
     if ( Jb_TransportOnline(AIM_SERVICE) == 0 && Jb_TransportOnline(ICQ_SERVICE) == 0 && Jb_TransportOnline(MSN_SERVICE) == 0 && Jb_TransportOnline(YAHOO_SERVICE) == 0 && Jb_TransportOnline(IRC_SERVICE) == 0 ) break;

    }

  if( (handle = Ns_DbPoolGetHandle("jabber")) != NULL )
    { Ns_Set *row;Ns_Log(Debug , "Jabber Client got a db_handle from pool jabber jipii" );
      if((row = Ns_DbSelect(handle , "select xml from jb_xml_to_send" )) != NULL) 
        {
         while(Ns_DbGetRow(handle , row) == NS_OK)
              {
	 
               Ns_RWLockRdLock(JConnLock);
                if(JCgetConnState() != 0) {Ns_RWLockUnlock(JConnLock); break;}
                 jab_send_raw(JABBERConn->conn ,(char*)Ns_SetGet(row , "xml"));  
                  Ns_RWLockUnlock(JConnLock);          
              }

         } 
      Ns_DbPoolPutHandle(handle);
   
    }


if( (handle = Ns_DbPoolGetHandle("jabber")) != NULL )
    { Ns_Set *row;Ns_Log(Debug , "Jabber Client got a db_handle from pool jabber jipii" );
      if((row = Ns_DbSelect(handle , "select message, screen from jb_message_log where conn_state='-1'" )) != NULL) 
        {
         while(Ns_DbGetRow(handle , row) == NS_OK)
	   {pool p = pool_heap(910);
	    jid id = jid_new(p,(char*)Ns_SetGet(row ,"screen"));
            char* sql;
            int db;
	    if(Jb_TransportOnline(id->server) == 0)
	      {  xmlnode msg = jutil_msgnew("chat" , jid_full(id) , NULL , (char*)Ns_SetGet(row , "message" ) );
		 xmlnode_put_attrib(msg , "from" , COMMUNITY_CLIENT);
               
               Ns_RWLockRdLock(JConnLock);
                if(JCgetConnState() != 0) {Ns_RWLockUnlock(JConnLock); xmlnode_free(msg); pool_free(p); break;}
                 jab_send(JABBERConn->conn ,msg);  
                  Ns_RWLockUnlock(JConnLock);
		  sql = pmalloc(p, 760 * sizeof(char));
                   snprintf(sql , 761 , "update jb_message_log set conn_state='0' , send = sysdate where message = '%s' and screen = '%s'" , Ns_SetGet(row , "message") , jid_full(id) );
		    db =  JABBER_Dbml_Main(sql);

               xmlnode_free(msg);
                pool_free(p);          
            }
	   }
         } 
      Ns_DbPoolPutHandle(handle);
   
    }

  
}



int Jb_TransportOnline(char* url)
{
  if(j_strcmp(url ,AIM_SERVICE) == 0) return service_online[JB_AIM];
  if(j_strcmp(url, ICQ_SERVICE) == 0) return service_online[JB_ICQ];
  if(j_strcmp(url ,YAHOO_SERVICE) == 0) return service_online[JB_YAHOO];
  if(j_strcmp(url ,MSN_SERVICE) == 0) return service_online[JB_MSN];
  if(j_strcmp(url ,IRC_SERVICE) == 0) return service_online[JB_IRC];
  if(j_strcmp(url ,CONFERENCE_SERVICE) == 0) return service_online[JB_CONFERENCE];
  if(j_strcmp(url ,JABBER_SERVER) == 0) return service_online[JB_JABBER];
  if(j_strcmp(url , "NOT_SET") == 0) return -2;
  return -1;  
}


void Jb_Sleep(int sec)
{ int timeout;
  Ns_Mutex mutx;
  Ns_Event evnt;

  Ns_MutexInit(&mutx);
  Ns_InitializeEvent(&evnt);



  Ns_MutexLock(&mutx);
  timeout =  Ns_UTimedWaitForEvent(&evnt , &mutx , sec , 0);
  Ns_MutexUnlock(&mutx); 

}



long int Jb_StackRemain(int address)
{ unsigned long int remain_bytes = 0;
  unsigned long int pool_address;
  unsigned long int pool_ind_address;
  unsigned long int cur_address;
  unsigned long int pool_and_address;
  unsigned long int ret;
 Ns_Pool* pool = NULL;

  
 pool = Ns_ThreadPool();

 pool_address = ( unsigned long int)pool;
 pool_ind_address = ( unsigned long int) *pool;
 pool_and_address =  (unsigned long int)&pool;

 cur_address = (long int)&address;

 remain_bytes = cur_address - pool_address;
 Ns_Log(Notice , "pool_address = %d , pool_ind_address = %d , pool_and_address = %d , cur_address = %d , remain_bytes = %d "  ,pool_address , pool_ind_address , pool_and_address , remain_bytes );
 
 ret = Jb_StackRemain(address);

 return remain_bytes;

}



















