 /* ------------------------------------------------------------------------
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *	
 * 
 *
 *   Copyright Sussdorff & Roy 2001 (www.sussdorff-roy.com)
 *   
 *   Developers: Malte Fliedner  ( maltefliedner@aol.com )
 *               Bjoern Kiesbye  ( xkiesbye@aol.com )       
 * 
 * Acknowledgements
 * 
 * Special thanks to the Jabber Open Source contributors for their
 * suggestions and support of Jabber and to Malte Sussdorff for his support
 * and for giving us the possibility to work on this Project.
 * 
 * --------------------------------------------------------------------------*/




//#include "ns.h"

//#include "nstcl.h"
//#include "nsthread.h" 
#include "../jabber/lib_jclient.h" 
//#include  "jabber/jabber.h"

 
 

int Ns_ModuleVersion = 1;
static Tcl_CmdProc JB_Login;               // login of the Comunity client in to the jabber server  (should be on startup) 
static Ns_TclInterpInitProc JB_LoginInit;  
static Tcl_CmdProc JB_Message;             // Sending a message from the community to the Client
static Ns_TclInterpInitProc JB_MessageInit;
static Tcl_CmdProc JB_SetPresence;
static Ns_TclInterpInitProc JB_SetPresenceInit;
static Tcl_CmdProc JB_Logout;                // logout of the  Comunity Client
static Ns_TclInterpInitProc JB_LogoutInit;
static Tcl_CmdProc JB_Chat;                //start Chat between two users
static Ns_TclInterpInitProc JB_ChatInit;
static Tcl_CmdProc JB_Register;            //register new user
static Ns_TclInterpInitProc JB_RegisterInit;
static Tcl_CmdProc JB_Unregister;            //unregister left user
static Ns_TclInterpInitProc JB_UnregisterInit;
static Tcl_CmdProc JB_AddBuddy;            //Add's 1 to n Buddys to a user roster
static Ns_TclInterpInitProc JB_AddBuddyInit;
static Tcl_CmdProc JB_RemoveBuddy;            //Remove's 1 to n Buddys from a user roster, the temp. roster
static Ns_TclInterpInitProc JB_RemoveBuddyInit;  //in the client will not be updated
static Tcl_CmdProc JB_GetConnState;            //returns 0 if Client is online or -1 if client is offline
static Ns_TclInterpInitProc JB_GetConnStateInit;
static Tcl_CmdProc JB_SendXML;
static Ns_TclInterpInitProc JB_SendXMLInit;
static Tcl_CmdProc JB_AddTransportBuddy;
static Ns_TclInterpInitProc JB_AddTransportBuddyInit;
static Tcl_CmdProc JB_RemoveTransportBuddy;
static Ns_TclInterpInitProc JB_RemoveTransportBuddyInit;
static Tcl_CmdProc JB_GetTransportUrlFromId;
static Ns_TclInterpInitProc JB_GetTransportUrlFromIdInit;
static Tcl_CmdProc JB_SpellCheck;
static Ns_TclInterpInitProc JB_SpellCheckInit;
static Tcl_CmdProc JB_ActiveConferenceRooms;
static Ns_TclInterpInitProc JB_ActiveConferenceRoomsInit;
static Tcl_CmdProc JB_ActiveRoomMembers;
static Ns_TclInterpInitProc JB_ActiveRoomMembersInit;
static Tcl_CmdProc JB_CreateConferenceRoom;
static Ns_TclInterpInitProc JB_CreateConferenceRoomInit;
static Tcl_CmdProc JB_SendConferenceInvite;
static Ns_TclInterpInitProc JB_SendConferenceInviteInit;
static Tcl_CmdProc JB_DelConferenceRoom;
static Ns_TclInterpInitProc JB_DelConferenceRoomInit;
static Tcl_CmdProc JB_SendConferenceSubject;
static Ns_TclInterpInitProc JB_SendConferenceSubjectInit;
static Tcl_CmdProc JB_RestartConferenceSubject;
static Ns_TclInterpInitProc JB_RestartConferenceSubjectInit;
static Tcl_CmdProc JB_StackRemain;
static Ns_TclInterpInitProc JB_StackRemainInit;


extern char* JABBERgetRegState(char* screen);
extern JABBER_Conn *JABBERConn;
extern Ns_Mutex *FDLock;
extern Ns_RWLock *JConnLock;
extern pool p; 
extern char *COMMUNITY_CLIENT;
extern char *COMMUNITY_NICK;
extern char *JABBER_SERVER;
extern char *CLIENT_PASS_JB;
extern char *VIRTUAL_SERVER_NAME;
extern char *AIM_SERVICE;
extern char *ICQ_SERVICE;
extern char *YAHOO_SERVICE;
extern char *MSN_SERVICE;
extern char *IRC_SERVICE;
extern char *CONFERENCE_SERVICE; 
extern Jb_Ring response_ring;
extern Ns_RWLock* ConfRoomsLock;
extern Jb_Conf_Room ConfRooms;
extern int UTimeSockRead;
extern int SockBuffStandartSize;

int JB_StackRemain(ClientData dummy, Tcl_Interp *interp, int argc , char **argv)
{ //charlist user;
  int cur = 0 ;
  long int  remain = 0 ;
  
  /* para check */

  //Ns_Log(Error, "TclList2CharArray:argc: %d\nargv:  %s " ,argc  ,argv);
if (argc < 2 ) {
	  Tcl_AppendResult(interp, "wrong # args: should be \"", argv[0], " remaining_memory_size", NULL);
                return TCL_ERROR;
               }  

 remain = Jb_StackRemain(1234);


 snprintf( argv[1], 21 , "%d" , remain);
  interp->result = argv[1];
  return TCL_OK;

}



int JB_RemoveBuddy(ClientData dummy, Tcl_Interp *interp, int argc , char **argv)
{ //charlist user;
  int i;
  int flag;
  /* para check */

  //Ns_Log(Error, "TclList2CharArray:argc: %d\nargv:  %s " ,argc  ,argv);
if (argc < 3) {
	  Tcl_AppendResult(interp, "wrong # args: should be \"", argv[0], " the triggering user's screenname and then at least one more valid screenname\"", NULL);
                return TCL_ERROR;
               }  

//user = jb_listtochar(argv[1]);
  
/*for(i = 1; i < argc; i++) {
     if (charcheck(argv[i]) != 0) {
       //spooler( sp , "In " , argv[i] , " illegal characters used. Do not define a server. \"" , sp);
       //message = spool_print(sp);
       //Tcl_AppendResult(interp, "wrong args in \"",argv[0], ": In " , argv[i], " illegal characters used. Do not define a server. \"", NULL);
       flag = -1;
       Tcl_AppendResult(interp, argv[i],'\0', NULL);
     }
     
  }
 if (flag == -1) {
 return TCL_OK;
 }      
*/
 //Lock the JConn object before we trigger functions using the same JConn  
 Ns_RWLockRdLock(JConnLock);

if(JCgetConnState() == -1)
  {interp->result = "-1";
               Ns_RWLockUnlock(JConnLock);
	       //Unlock the Jconn object after functions returned
               return TCL_OK;
	       } 
 
  JABBER_AddRemBuddy(JABBERConn, argv, argc, JB_REMOVEBUDDY_C);
 
  Ns_RWLockUnlock(JConnLock);
  //Unlock the Jconn object after function returned

  
 //pool_free(user->p);
 
  interp->result = "0";
  return TCL_OK;

}
int JB_SendXML(ClientData dummy, Tcl_Interp *interp, int argc , char **argv)
{
  void * *ret;
  int result;
  xmlnode send = NULL;
  
  send = xmlnode_str(argv[1], j_strlen(argv[1]));
  if(!send){interp->result = "Corupted XML";return TCL_OK;}
 //Lock the JConn object before we trigger functions using the same JConn  
 Ns_RWLockRdLock(JConnLock);
 //jab_send_raw(JABBERConn->conn, argv[1]);
   ret = malloc(sizeof(void*));
   result = Jb_Send_Wait_For_Response(JABBERConn->conn , 20 ,send , ret , NULL);
 Ns_RWLockUnlock(JConnLock);
 //Unlock the Jconn object after function returned
 
 if(result == NS_TIMEOUT) 
   {  interp->result = "Timed Out";
          return TCL_OK;
       }    
     else if(result != NS_OK)
       { 
	 interp->result = "Undifined Error";
         return TCL_OK;
       }
      else 
        { 
          interp->result = xmlnode2str((xmlnode)ret[0]);
          Ns_Log(Notice, "Jb_sendxml giebt zurueck %s",xmlnode2str((xmlnode)ret[0]));
          return TCL_OK;
        } 
 
 
			  
 
}



int JB_AddBuddy(ClientData dummy, Tcl_Interp *interp, int argc , char **argv)
{ 
  int flag;
  int i;
  //charlist user;
  //error checking
if (argc < 2) {
	  Tcl_AppendResult(interp, "wrong # args: should be \"", argv[0], " the triggering user's screenname and then at least one more valid screenname \"", NULL);
                return TCL_ERROR;
               }  

// user = jb_listtochar(argv[1]);
/*for(i = 1 ; i < argc; i++) {
     if ( charcheck(argv[i]) ) {
       //spooler( sp , "In " , argv[i] , " illegal characters used. Do not define a server. \"" , sp);
       //message = spool_print(sp);
         Tcl_AppendResult(interp, "wrong args in \"" ,argv[0], ": In " , argv[i] , " illegal characters used. Do not define a server. \"", NULL);/
       flag = -1;
       Tcl_AppendResult(interp, argv[i]," " , NULL);
       
     }
 }*/
    if (flag == -1) {
 return TCL_OK;
 }     

   //Lock the JConn object before we trigger functions using the same JConn  
   Ns_RWLockRdLock(JConnLock);

if(JCgetConnState() == -1)
  {interp->result = "-1";
               Ns_RWLockUnlock(JConnLock);
	       //Unlock the Jconn object after function returned
               return TCL_OK;
	       } 


     
  JABBER_AddRemBuddy(JABBERConn, argv, argc, JB_ADDBUDDY_C);

  Ns_RWLockUnlock(JConnLock);
  //Unlock the Jconn object after function returned


  /*for(i=0;i<user->len;i++){ 
 Tcl_AppendResult(interp, "" , "" , "" , "" ,"test1 ",NULL);
                          }
			  pool_free(user->p);*/
  interp->result = "0";
    return TCL_OK;
}



int JB_Chat(ClientData dummy, Tcl_Interp *interp, int argc , char **argv)
{
  /* para check */
if (argc != 3) {
	  Tcl_AppendResult(interp, "wrong # args: should be \"", argv[0], " jid jid\"", NULL);
                return TCL_ERROR;
               }
if( charcheck(argv[1])  || charcheck(argv[2])  ) {
	  Tcl_AppendResult(interp, "wrong args: \"", argv[0], " illegal characters used. Do not define a server. \"", NULL);
                return TCL_ERROR;
}
 


 //Lock the JConn object before we trigger functions using the same JConn  
 Ns_RWLockRdLock(JConnLock);

if(JCgetConnState() == -1)
  {interp->result = "-1";
               Ns_RWLockUnlock(JConnLock);
               //Unlock the Jconn object after function returned
               return TCL_OK;
	       } 

 JABBER_Chat(JABBERConn, argv);

  Ns_RWLockUnlock(JConnLock);
  //Unlock the Jconn object after function returned

 interp->result="0"; 
 return TCL_OK;
}





int JB_SetPresence(ClientData dummy, Tcl_Interp *interp, int argc, char **argv) 
{ 
  int success;
 //Lock the JConn object before we trigger functions using the same JConn  
 Ns_RWLockRdLock(JConnLock);

    if(JCgetConnState() == -1)
  {interp->result = "-1";
               Ns_RWLockUnlock(JConnLock);
               //Unlock the Jconn object after function returned
               return TCL_OK;
	       }

  success = JABBER_ChangeState(JABBERConn, JABBER_ONLINE);
 
   Ns_RWLockUnlock(JConnLock);
  //Unlock the Jconn object after function returned
 
  if(success == -1) {
    interp->result="-1";
  } else {
    interp->result="0";
  }
  return TCL_OK;
}

int JB_Message(ClientData dummy, Tcl_Interp *interp, int argc, char **argv)
{       int success;
        if (argc != 3) {
	  Tcl_AppendResult(interp, "wrong # args: should be \"", argv[0], " jid/screen message\"", NULL);
                return TCL_ERROR;
        }


 //Lock the JConn object before we trigger functions using the same JConn  
 Ns_RWLockRdLock(JConnLock);
        
if(JCgetConnState() == -1)
  {interp->result = "-1";
               Ns_RWLockUnlock(JConnLock);
	       //Unlock the Jconn object after function returned
               return TCL_OK;
	       } 

	success = JABBER_SendMessage(JABBERConn, argv[1], argv[2]);

  Ns_RWLockUnlock(JConnLock);
  //Unlock the Jconn object after function returned

	if(success == -1) {
	  interp->result="-1";
	} else {
	  interp->result="0";
	}
  	return TCL_OK;
}


int JB_Login(ClientData dummy, Tcl_Interp *interp, int argc, char **argv) 
{ 

 


  switch (Jb_LoginMain()) {
    case -1 : interp->result = "-1"; break;
    case  1 : interp->result = "0"; break;
    default : 
      interp->result = "-1"; break; 
                        }

      return TCL_OK;

      /* this is old stuff only here if the new doesn't work proberly
/Lock the JConn object before we trigger functions using the same JConn  
 Ns_RWLockWrLock(JConnLock);
 Ns_Log(Notice, "JConn wurde gelocked","X");
  JABBERConn = JABBER_Login(COMMUNITY_CLIENT, CLIENT_PASS_JB, "",0);
  
  if(JABBERConn == NULL || JABBERConn->conn->state == JCONN_STATE_OFF) {
    interp->result="-1";
  } else {
    Ns_RWLockUnlock(JConnLock);
    Ns_RWLockRdLock(JConnLock);
    JABBER_AfterLogin(JABBERConn);
    interp->result="0";
  }
 
  Ns_RWLockUnlock(JConnLock);
   Ns_Log(Notice, "JConn wurde ungelocked","X");
 /Unlock the Jconn object after function returned
 
  return TCL_OK;*/
}



int JB_Logout(ClientData dummy, Tcl_Interp *interp, int argc, char **argv)
{       
        int success;

 //Lock the JConn object before we trigger functions using the same JConn  
 Ns_RWLockWrLock(JConnLock);

	success = JABBER_Logout(JABBERConn);

  Ns_RWLockUnlock(JConnLock);
  //Unlock the Jconn object after function returned

	if(success == -1) {
	  interp->result="-1";
	} else {
	  interp->result="0";
	}
  	return TCL_OK;
}


 

int JB_Register(ClientData dummy, Tcl_Interp *interp, int argc , char **argv)
{
    xmlnode x,y;
  /* para check */ 
if (argc != 3) {
	  Tcl_AppendResult(interp, "wrong # args: should be \"", argv[0], " username password \"", NULL);
                return TCL_ERROR;
               }
if ( charcheck(argv[1]) ) {
  //Tcl_AppendResult(interp, "wrong args: ", argv[0], " illegal characters used. Do not define a server. \"", NULL);  
          interp->result = argv[1];      
	  return TCL_OK;
}
 //Lock the JConn object before we trigger functions using the same JConn  
 Ns_Log(Notice , "Im jb_register 1234567,step 1 values argv1 = %s, argv2= %s",argv[1],argv[2]);
 Ns_RWLockRdLock(JConnLock);
 Ns_Log(Notice , "Im jb_register 1234567, step 2values argv1 = %s, argv2= %s",argv[1],argv[2]);
if(JCgetConnState() == -1)
  {interp->result = "-1";
      Ns_RWLockUnlock(JConnLock);
      //Unlock the Jconn object after function returned
      
              return TCL_OK;
	       } 

Ns_Log(Notice , "Im jb_register 1234567, step 3values argv1 = %s, argv2= %s, jabberconn%X",argv[1],argv[2], JABBERConn);
 interp->result = JABBER_Register(JABBERConn, argv);
   Ns_Log(Notice , "Im jb_register 1234567, step 4 values argv1 = %s, argv2= %s",argv[1],argv[2]);
  Ns_RWLockUnlock(JConnLock);
  //Unlock the Jconn object after function returned
Ns_Log(Notice , "Im jb_register out 1234567, step 5 values argv1 = %s, argv2= %s",argv[1],argv[2]);
 
  return TCL_OK;
} 

int JB_Unregister(ClientData dummy, Tcl_Interp *interp, int argc , char **argv)
{
    xmlnode x,y;
  /* para check */ 
if (argc != 3) {
	  Tcl_AppendResult(interp, "wrong # args: should be \"", argv[0], " username password \"", NULL);
                return TCL_ERROR;
               }
if ( charcheck(argv[1]) || !JABBERgetRegState(argv[1]) ) {
  //Tcl_AppendResult(interp, "wrong args: ", argv[0], " illegal characters used. Do not define a server. \"", NULL);  
          interp->result = argv[1];      
	  return TCL_OK;
}
 //Lock the JConn object before we trigger functions using the same JConn  
 Ns_RWLockRdLock(JConnLock);
 
if(JCgetConnState() == -1)
  {interp->result = "-1";
      Ns_RWLockUnlock(JConnLock);
      //Unlock the Jconn object after function returned
           
              return TCL_OK;
	       } 


 JABBER_Unregister(JABBERConn, argv);
   
  Ns_RWLockUnlock(JConnLock);
  //Unlock the Jconn object after function returned

 interp->result = "0";
  return TCL_OK;
} 




int JB_getConnState (ClientData dummy, Tcl_Interp *interp, int argc, char **argv)
{ 
  //Lock the JConn object before we trigger functions using the same JConn  
 Ns_RWLockRdLock(JConnLock);

  if(JCgetConnState() == 0) {
      interp->result="0";
        Ns_RWLockUnlock(JConnLock);
        //Unlock the Jconn object after function returned
          return TCL_OK;
    } 
   Ns_RWLockUnlock(JConnLock);
  //Unlock the Jconn object after function returned

 interp->result="-1";
 return TCL_OK;
}      
int JB_AddTransportBuddy(ClientData dummy, Tcl_Interp *interp, int argc, char **argv)
{ int trans;
  pool p = pool_new();
  jid id; 
  Ns_Log(Notice, "jb_addtransportbuddy values argv1=%s argv2=%s argv3=%s " ,argv[1],argv[2],argv[3]);
    if(argc == 4)
      {if( (trans = j_atoi(argv[3],0) ) )
         {           
	     switch (trans) {
		 case JB_JABBER :
		   id = jid_new(p, JABBER_SERVER);   Ns_Log(Notice, "jb_addtransportbuddy jabber");break;
	         case JB_AIM :
                   id = jid_new(p, AIM_SERVICE);   Ns_Log(Notice, "jb_addtransportbuddy aim");break;
	         case JB_ICQ :
                   id =  jid_new(p, ICQ_SERVICE);   Ns_Log(Notice, "jb_addtransportbuddy icq"); break;
          	 case JB_MSN :
                   id =  jid_new(p, MSN_SERVICE);   Ns_Log(Notice, "jb_addtransportbuddy msn");break;
	         case JB_YAHOO :
                   id =  jid_new(p, YAHOO_SERVICE);   Ns_Log(Notice, "jb_addtransportbuddy yahoo");break;
	         case JB_IRC :
                   id =  jid_new(p, IRC_SERVICE);   Ns_Log(Notice, "jb_addtransportbuddy irc");break;
	         default :
		     interp->result = "-1";
                     pool_free(p);
                     return TCL_OK;  
                    break;
	                    }
       
	         jid_set(id, argv[1] , JID_USER);
                 Ns_Log(Notice, "jb_addtransportbuddy jid = %s, ICQ_SERVER = %s " ,jid_full(id) , ICQ_SERVICE);
	               //Ready top go to admin             
                      //Lock the JConn object before we trigger functions using the same JConn  
                      Ns_RWLockRdLock(JConnLock);
           
                     if(JCgetConnState() == 0) 
                       {
			   interp->result = JABBER_AddTransportBuddy(JABBERConn , id , argv[2]);
                           pool_free(p);
                           
                           Ns_RWLockUnlock(JConnLock);
                           //Unlock the Jconn object after function returned
                           return TCL_OK;
                        } 
                      Ns_RWLockUnlock(JConnLock);
                      //Unlock the Jconn object after function returned
                   
         }
      }
    pool_free(p);
    interp->result="-1";
    return TCL_OK;
        
       
    
                           
}      

int JB_RemoveTransportBuddy(ClientData dummy, Tcl_Interp *interp, int argc, char **argv)
{ int trans;
  pool p = pool_new();
  jid id; 
  Ns_Log(Notice, "jb_removetransportbuddy values argv1=%s argv2=%s  " ,argv[1],argv[2]);
    if(argc == 3)
      {if( (trans = j_atoi(argv[2],0) ) &&  ( (trans > 0) && (trans <=5 ) ) )
         {           
	     switch (trans) {
		 case JB_JABBER :
		   id = jid_new(p, JABBER_SERVER);  break;
	         case JB_AIM :
                   id = jid_new(p, AIM_SERVICE);  break;
	         case JB_ICQ :
                   id =  jid_new(p, ICQ_SERVICE);  break;
          	 case JB_MSN :
                   id =  jid_new(p, MSN_SERVICE);  break;
	         case JB_YAHOO :
                   id =  jid_new(p, YAHOO_SERVICE);  break;
	         case JB_IRC :
                   id =  jid_new(p, IRC_SERVICE);  break;
	         default :
		     interp->result = "-1";
                     pool_free(p);
                     return TCL_OK;  
                    break;
	                    }
       
	         jid_set(id, argv[1] , JID_USER);
                 Ns_Log(Notice, "jb_removetransportbuddy jid = %s " ,jid_full(id));
	                    //Ready top go to admin             
                           //Lock the JConn object before we trigger functions using the same JConn  
                           Ns_RWLockRdLock(JConnLock);
           
                      
                     
			   interp->result = JABBER_RemoveTransportBuddy(JABBERConn , id );
                           pool_free(p);
                           
                           Ns_RWLockUnlock(JConnLock);
                           //Unlock the Jconn object after function returned
                         
                            return TCL_OK;
                         
                                      
         }
      } 
    pool_free(p);
    interp->result="-1";
    return TCL_OK;
                       
}      


int JB_GetTransportUrlFromId(ClientData dummy, Tcl_Interp *interp, int argc, char **argv)
{ int trans;
     if(argc == 2)
      {if( (trans = j_atoi(argv[1],0) ) &&  ( (trans > 0) && (trans <=7 ) ) )
         { Ns_RWLockRdLock(JConnLock);          
	     switch (trans) {
		 case JB_JABBER :
		   interp->result = JABBER_SERVER; break;
	         case JB_AIM :
                   interp->result = AIM_SERVICE;  break;
	         case JB_ICQ :
                   interp->result = ICQ_SERVICE;  break;
          	 case JB_MSN :
                   interp->result =  MSN_SERVICE;  break;
	         case JB_YAHOO :
                   interp->result = YAHOO_SERVICE;  break;
	         case JB_IRC :
                   interp->result = IRC_SERVICE;  break;
	         case JB_CONFERENCE :
                   interp->result = CONFERENCE_SERVICE; break;
                 default :
		     interp->result = "-1";
		     break;
	     }
                
	     Ns_RWLockUnlock(JConnLock);
             return TCL_OK;  
              
	                 
       
           
                      
                     
			  
                         
                                      
         }
      }
   
    interp->result="-1";
    return TCL_OK;
                       
}      


int JB_SpellCheck (ClientData dummy, Tcl_Interp *interp, int argc, char **argv)
{ 
  if( argc != 2) {
             Tcl_AppendResult(interp, "wrong # args: should be \"", argv[1], " the  screenname to be spellchecked.\"", NULL);
                return TCL_ERROR;           
                  }
  switch(charcheck(argv[1])) {
 
  case 1 : interp->result="-1";break;
  case 0 : interp->result="0";break;
  default : interp->result ="-1";break;
  }

 return TCL_OK; 
}

int JB_CreateConferenceRoom (ClientData dummy, Tcl_Interp *interp, int argc, char **argv)
{ int ret = 0;
  char* thread_id = NULL;
  

  if( argc < 6 || argc > 7 ) {
    Tcl_AppendResult(interp, "wrong # args: should be \"", argv[1], " RoomName , user_id , Threadname , creator_jid and short description [possibly a thread_id].\"", NULL);
    
    return TCL_ERROR;           
                 }

  if(  charcheck(argv[1])  )
    {
      Tcl_AppendResult(interp, "wrong # arg: RoomName \"", argv[1], " Iligal characters  used. Use [A-z] , [0-9] , \'-\' and \'_\' \"", NULL);
      return TCL_ERROR;           
     

    }


  if( argc == 7) 
    {
      thread_id = argv[6];
    } 



  Ns_RWLockRdLock(JConnLock);
  if((JCgetConnState()))
    { interp->result = "-1";Ns_RWLockUnlock(JConnLock); return TCL_OK;}

  
  ret = Jb_CreateConferenceRoom(argv[1], argv[2] , argv[3] , argv[4] , argv[5] , JABBERConn->conn , thread_id);
  
  if( (ret == CONFERENCE_OK) ) 
       {interp->result = "0";}
  else {interp->result = "-1";}

  Ns_RWLockUnlock(JConnLock);

return TCL_OK;
}

int JB_ActiveConferenceRooms (ClientData dummy, Tcl_Interp *interp, int argc, char **argv)
{ Ns_Set* rooms = NULL;

  if( argc != 1) {
             Tcl_AppendResult(interp, "wrong # args: should be \"", argv[1], " No arguments , a set with all rooms will be returned .\"", NULL);
                return TCL_ERROR;           
                 }

  Ns_RWLockRdLock(JConnLock);
  if((JCgetConnState()))
    { interp->result = "-1";Ns_RWLockUnlock(JConnLock); return TCL_OK;}

       Ns_RWLockRdLock(ConfRoomsLock);          
        rooms = Jb_ActiveConferenceRooms(ConfRooms , interp);
         Ns_RWLockUnlock(ConfRoomsLock);          
Ns_Log(Notice , "Active roomslast room name: tcl_jc"  );
  Ns_RWLockUnlock(JConnLock);

  if( (rooms != NULL) ) 
       {return Ns_TclEnterSet(interp , rooms , NS_TCL_SET_TEMPORARY | NS_TCL_SET_DYNAMIC);}
  else {interp->result = "-1";}


return TCL_OK;
}

int JB_ActiveRoomMembers (ClientData dummy, Tcl_Interp *interp, int argc, char **argv)
{ Ns_Set* users = NULL;

  if( argc != 2) {
             Tcl_AppendResult(interp, "wrong # args: should be \"", argv[1], " The Name of the Room , a set with all Room Members will be returned .\"", NULL);
                return TCL_ERROR;           
                 }

Ns_Log(Notice , "Active members room name: %s , %s" , argv[0], argv[1]  );
  Ns_RWLockRdLock(JConnLock);
  if((JCgetConnState()))
    { interp->result = "-1"; Ns_RWLockUnlock(JConnLock);return TCL_OK;}

     Ns_RWLockRdLock(ConfRoomsLock);  
      users = Jb_ActiveRoomMembers(argv[1] , ConfRooms , interp);
       Ns_RWLockUnlock(ConfRoomsLock);


  Ns_RWLockUnlock(JConnLock);

  if( (users != NULL) ) 
       {return Ns_TclEnterSet(interp , users , NS_TCL_SET_TEMPORARY | NS_TCL_SET_DYNAMIC);}
  else {interp->result = "-1";}


return TCL_OK;
}

int JB_SendConferenceInvite (ClientData dummy, Tcl_Interp *interp, int argc, char **argv)
{ int ret = 0 , type = 0;
  
  if( argc != 6 ||    ( ( type = j_atoi(argv[5] , 0) ) !=1 && type != 2  )   ) {
             Tcl_AppendResult(interp, "wrong # args: should be \"", argv[1], "1. The Jid to send the invite to. 2. The Name of the Room. 3. The Topic discused in te room. 4. A short message \"Hi I'am ... join us..\" to display.\" 5. Type of the invite 1 or 2 .", NULL);
                return TCL_ERROR;           
                 }

  Ns_RWLockRdLock(JConnLock);
  if((JCgetConnState()))
    { interp->result = "-1";Ns_RWLockUnlock(JConnLock); return TCL_OK;}
  
  if( (ret = Jb_SendConferenceInvite(argv[1] ,argv[2] , argv[3] , argv[4] , type , JABBERConn->conn))  )
   { switch (ret){
       case -1:interp->result = "-1";break;
       case -10:interp->result = "-10";break;
       default: interp->result = "-1";break;
                 }
   } else {interp->result = "0";}
  

  Ns_RWLockUnlock(JConnLock);

  


return TCL_OK;
}
 
int JB_DelConferenceRoom(ClientData dummy, Tcl_Interp *interp, int argc, char **argv)
{ pool p = pool_heap(500);
 jid id = NULL;

  if( argc != 2) {
             Tcl_AppendResult(interp, "wrong # args: should be \"", argv[1], " The name of the Conference Room the Webserver should stop listening to! \"", NULL);
                return TCL_ERROR;           

                   }

  id = jid_new(p , argv[1]);
  if(id->user == NULL)
    {jid_set(id , argv[1] , JID_USER); 
     jid_set(id , CONFERENCE_SERVICE , JID_SERVER);
    }  

  Ns_RWLockRdLock(JConnLock);
  if((JCgetConnState()))
    {  interp->result = "-1";Ns_RWLockUnlock(JConnLock);pool_free(p); return TCL_OK;}
  
  Jb_DelConferenceRoom(ConfRooms , id , JABBERConn->conn); 
  interp->result = "0";

  Ns_RWLockUnlock(JConnLock);
  pool_free(p);
  


return TCL_OK;
}

int JB_SendConferenceSubject (ClientData dummy, Tcl_Interp *interp, int argc, char **argv)
{ int ret = 0;
  char* thread_id = NULL;

  if( argc < 4  || argc > 5) {
             Tcl_AppendResult(interp, "wrong # args: should be \"", argv[1], " RoomName , New Thread name , explaination of thread Name [optinal existing thread_id].\"", NULL);
                return TCL_ERROR;           
                 }

  if(argc == 5 ) { thread_id = argv[4];}

  Ns_RWLockRdLock(JConnLock);
  if((JCgetConnState()))
    { interp->result = "-1";Ns_RWLockUnlock(JConnLock); return TCL_OK;}
  
  ret = Jb_SendConferenceSubject(argv[1], argv[2] , argv[3]  , JABBERConn->conn , thread_id);
  
  if( (ret == CONFERENCE_OK) ) 
       {interp->result = "0";}
  else {interp->result = "-1";}

  Ns_RWLockUnlock(JConnLock);

return TCL_OK;
}


int JB_RestartConferenceSubject (ClientData dummy, Tcl_Interp *interp, int argc, char **argv)
{ int ret = 0;
  

  if(  argc != 5) {
             Tcl_AppendResult(interp, "wrong # args: should be \"", argv[1], " RoomName , Old Thread name , explaination of thread Name , existing thread_id.\"", NULL);
                return TCL_ERROR;           
                 }

  

  Ns_RWLockRdLock(JConnLock);
  if((JCgetConnState()))
    { interp->result = "-1";Ns_RWLockUnlock(JConnLock); return TCL_OK;}
  
  if( (ret = Jb_CreateConferenceRoom(argv[1] , "1" , COMMUNITY_CLIENT , argv[2] , argv[2] , JABBERConn->conn , argv[4])) == CONFERENCE_OK )
    { 
      interp->result = "0";

    }  
  else if( ret ==  CONFERENCE_ROOM_ACTIVE  )
    {
      ret = Jb_SendConferenceSubject(argv[1], argv[2] , argv[3]  , JABBERConn->conn , argv[4]);
      
        if( (ret == CONFERENCE_OK) ) 
	     {interp->result = "0";}
	else {interp->result = "-1";}
       
    }
  else 
    {
      interp->result = "-1";
    }


  Ns_RWLockUnlock(JConnLock);

return TCL_OK;
}


static int JB_RemoveBuddyInit(Tcl_Interp *interp, void *context)
{
  Tcl_CreateCommand(interp, "jb_removebuddy", JB_RemoveBuddy, NULL, NULL);
  return NS_OK;
}


static int JB_AddBuddyInit(Tcl_Interp *interp, void *context)
{
  Tcl_CreateCommand(interp, "jb_addbuddy", JB_AddBuddy, NULL, NULL);
  return NS_OK;
}


static int JB_RegisterInit(Tcl_Interp *interp, void *context)
{
  Tcl_CreateCommand(interp, "jb_register", JB_Register, NULL, NULL);
  return NS_OK;
}


static int JB_UnregisterInit(Tcl_Interp *interp, void *context)
{
  Tcl_CreateCommand(interp, "jb_unregister", JB_Unregister, NULL, NULL);
  return NS_OK;
}

static int JB_ChatInit(Tcl_Interp *interp, void *context)
{
  Tcl_CreateCommand(interp, "jb_chat", JB_Chat, NULL, NULL);
  return NS_OK;
}

static int JB_LoginInit(Tcl_Interp *interp, void *context)
{
  Tcl_CreateCommand(interp, "jb_login", JB_Login, NULL, NULL);
  return NS_OK;
}

static int JB_MessageInit(Tcl_Interp *interp, void *context)
{
  Tcl_CreateCommand(interp, "jb_message", JB_Message, NULL, NULL);
  return NS_OK;
}

static int JB_SetPresenceInit(Tcl_Interp *interp, void *context)
{
  Tcl_CreateCommand(interp, "jb_setpresence", JB_SetPresence, NULL, NULL);
  return NS_OK;
}

static int JB_LogoutInit(Tcl_Interp *interp, void *context)
{
  Tcl_CreateCommand(interp, "jb_logout", JB_Logout, NULL, NULL);
  return NS_OK;
}

static int JB_GetConnStateInit(Tcl_Interp *interp, void *context)
{
  Tcl_CreateCommand(interp, "jb_getconnstate", JB_getConnState, NULL, NULL);
  return NS_OK;
}

static int JB_SendXMLInit(Tcl_Interp *interp, void *context)
{
  Tcl_CreateCommand(interp, "jb_sendxml", JB_SendXML, NULL, NULL);
  return NS_OK;
}

static int JB_AddTransportBuddyInit(Tcl_Interp *interp, void *context)
{
  Tcl_CreateCommand(interp, "jb_addtransportbuddy", JB_AddTransportBuddy, NULL, NULL);
  return NS_OK;
}

static int JB_RemoveTransportBuddyInit(Tcl_Interp *interp, void *context)
{
  Tcl_CreateCommand(interp, "jb_removetransportbuddy", JB_RemoveTransportBuddy, NULL, NULL);
  return NS_OK;
}

static int JB_GetTransportUrlFromIdInit(Tcl_Interp *interp, void *context)
{
  Tcl_CreateCommand(interp, "jb_get_transport_url_from_id", JB_GetTransportUrlFromId, NULL, NULL);
  return NS_OK;
}

static int JB_SpellCheckInit(Tcl_Interp *interp, void *context)
{
  Tcl_CreateCommand(interp, "jb_spellcheck", JB_SpellCheck, NULL, NULL);
  return NS_OK;
}

static int JB_CreateConferenceRoomInit(Tcl_Interp *interp, void *context)
{
  Tcl_CreateCommand(interp, "jb_createconferenceroom", JB_CreateConferenceRoom , NULL, NULL);
  return NS_OK;
}

static int JB_ActiveConferenceRoomsInit(Tcl_Interp *interp, void *context)
{
  Tcl_CreateCommand(interp, "jb_activeconferencerooms", JB_ActiveConferenceRooms , NULL, NULL);
  return NS_OK;
}

static int JB_ActiveRoomMembersInit(Tcl_Interp *interp, void *context)
{
  Tcl_CreateCommand(interp, "jb_activeroommembers", JB_ActiveRoomMembers , NULL, NULL);
  return NS_OK;
}

static int JB_SendConferenceInviteInit(Tcl_Interp *interp, void *context)
{
  Tcl_CreateCommand(interp, "jb_invite", JB_SendConferenceInvite , NULL, NULL);
  return NS_OK;
}

static int JB_DelConferenceRoomInit(Tcl_Interp *interp, void *context)
{
  Tcl_CreateCommand(interp, "jb_delconferenceroom", JB_DelConferenceRoom , NULL, NULL);
  return NS_OK;
}

static int JB_SendConferenceSubjectInit(Tcl_Interp *interp, void *context)
{
  Tcl_CreateCommand(interp, "jb_new_subject", JB_SendConferenceSubject , NULL, NULL);
  return NS_OK;
}

static int JB_RestartConferenceSubjectInit(Tcl_Interp *interp, void *context)
{
  Tcl_CreateCommand(interp, "jb_append_subject", JB_RestartConferenceSubject , NULL, NULL);
  return NS_OK;
}

static int JB_StackRemainInit(Tcl_Interp *interp, void *context)
{
  Tcl_CreateCommand(interp, "jb_stack_remain", JB_StackRemain , NULL, NULL);
  return NS_OK;
}


int Ns_ModuleInit(char *hServer, char *hModule)
{ char path[200]; 
  char *cache = NULL;
  char *CSockBuffStandartSize = NULL;
  char *CUTimeSockRead = NULL;
  char *PipePoolSize = NULL;
  char *PipeInterval = NULL;
  time_t InitPipeInterval = 300;
  long int InitPipePoolSize = 16384;

 snprintf(path, 200, "ns/server/%s/module/nsjabber", hServer);
 //path = Ns_ConfigPath(hServer, hModule, NULL);
VIRTUAL_SERVER_NAME = strdup((cache=hServer)?cache:"NOT SET!");
cache =  NULL;
COMMUNITY_CLIENT =  strdup( ( (cache= Ns_ConfigGetValue(path , "jid"))?cache:"NOT SET!"));
cache = NULL;
CLIENT_PASS_JB = strdup ( ( (cache = Ns_ConfigGetValue(path , "pw" ))?cache:"NOT SET!") );
cache = NULL;
JABBER_SERVER = strdup ( ((cache = Ns_ConfigGetValue(path , "jabber_server"))?cache:"NOT SET !") );
AIM_SERVICE = strdup ( ((cache = Ns_ConfigGetValue(path , "aim_transport"))?cache:"NOT SET !") );
ICQ_SERVICE = strdup ( ((cache = Ns_ConfigGetValue(path , "icq_transport"))?cache:"NOT SET !") );
YAHOO_SERVICE = strdup ( ((cache = Ns_ConfigGetValue(path , "yahoo_transport"))?cache:"NOT SET !") );
MSN_SERVICE = strdup ( ((cache = Ns_ConfigGetValue(path , "msn_transport"))?cache:"NOT SET !") );
CONFERENCE_SERVICE = strdup ( ((cache = Ns_ConfigGetValue(path , "conference_service"))?cache:"NOT SET !") );
COMMUNITY_NICK = strdup ( ((cache = Ns_ConfigGetValue(path , "community_nick"))?cache:"NOT SET !") );
CUTimeSockRead  = strdup ( ((cache = Ns_ConfigGetValue(path , "utimesockread"))?cache:"200") ); 
CSockBuffStandartSize =  strdup ( ((cache = Ns_ConfigGetValue(path , "sockbuffstandartsize"))?cache:"8192") );
PipePoolSize =  strdup ( ((cache = Ns_ConfigGetValue(path , "pipepoolsize"))?cache:"16384") );
PipeInterval =   strdup ( ((cache = Ns_ConfigGetValue(path , "pipeinterval"))?cache:"300") );



 UTimeSockRead = j_atoi(CUTimeSockRead,200);
 if(!UTimeSockRead) UTimeSockRead = 200;
SockBuffStandartSize  = j_atoi(CSockBuffStandartSize , 8192);
 if (!SockBuffStandartSize) SockBuffStandartSize = 8192;

 InitPipePoolSize = j_atoi(PipePoolSize , 16384);
 InitPipeInterval = j_atoi(PipeInterval , 300);


Ns_Log(Notice, "Values aus dem Config File:\n COMMUNITY_CLIENT = %s\n CLIENT_PASS_JB = %s \nJABBER_SERVER = %s \n server = %s \n path = %s \n %s" , COMMUNITY_CLIENT , CLIENT_PASS_JB , JABBER_SERVER , VIRTUAL_SERVER_NAME , path , cache);

  Ns_TclInitInterps(hServer, JB_RemoveBuddyInit, NULL);
  Ns_TclInitInterps(hServer, JB_AddBuddyInit, NULL);
  Ns_TclInitInterps(hServer, JB_RegisterInit, NULL);
  Ns_TclInitInterps(hServer, JB_UnregisterInit, NULL);
  Ns_TclInitInterps(hServer, JB_ChatInit, NULL);
  Ns_TclInitInterps(hServer, JB_LoginInit, NULL);
  Ns_TclInitInterps(hServer, JB_MessageInit, NULL);
  Ns_TclInitInterps(hServer, JB_SetPresenceInit, NULL);
  Ns_TclInitInterps(hServer, JB_LogoutInit, NULL);
  Ns_TclInitInterps(hServer, JB_GetConnStateInit, NULL);
  Ns_TclInitInterps(hServer, JB_SendXMLInit, NULL);
  Ns_TclInitInterps(hServer, JB_AddTransportBuddyInit, NULL);
  Ns_TclInitInterps(hServer, JB_RemoveTransportBuddyInit, NULL);
  Ns_TclInitInterps(hServer, JB_GetTransportUrlFromIdInit, NULL);
  Ns_TclInitInterps(hServer, JB_SpellCheckInit , NULL);
  Ns_TclInitInterps(hServer, JB_CreateConferenceRoomInit , NULL);
  Ns_TclInitInterps(hServer, JB_ActiveConferenceRoomsInit , NULL);
  Ns_TclInitInterps(hServer, JB_ActiveRoomMembersInit , NULL);
  Ns_TclInitInterps(hServer, JB_SendConferenceInviteInit , NULL);
  Ns_TclInitInterps(hServer, JB_DelConferenceRoomInit , NULL);
  Ns_TclInitInterps(hServer, JB_SendConferenceSubjectInit , NULL);
  Ns_TclInitInterps(hServer, JB_RestartConferenceSubjectInit , NULL);
  Ns_TclInitInterps(hServer, JB_StackRemainInit , NULL);
  //JABBERConn = JABBER_Login("COMMUNITY_CLIENT", "CLIENT_PASS_JB", "",0);
  //Seting up our global sync objects;
  p = pool_new();
  JConnLock = pmalloc(p , sizeof(Ns_RWLock));
  FDLock = pmalloc(p , sizeof(Ns_Mutex));
  ConfRoomsLock = pmalloc(p , sizeof(Ns_RWLock));
  ConfRooms = pmalloc(p, sizeof(_Jb_Conf_Room));
  ConfRooms->RoomName = "Dummy";
  ConfRooms->RoomID = "0000";
  ConfRooms->ThreadID = "00000";
  ConfRooms->subject = "Dummy room"; 
  ConfRooms->next = NULL;
  ConfRooms->lock = pmalloc(p , sizeof(Ns_RWLock));
  Ns_RWLockInit(ConfRooms->lock);
  ConfRooms->RoomMembers = NULL;
  ConfRooms->next = NULL;
    

  Ns_MutexInit(FDLock);
  Ns_RWLockInit(JConnLock);
  Ns_RWLockInit(ConfRoomsLock);
  
  if(j_strcmp(COMMUNITY_NICK , "NOT SET !" )  == 0)
  {jid id;
   id = jid_new(p , COMMUNITY_CLIENT);
   COMMUNITY_NICK = j_strdup(id->user);
  }   
  //Setting up our response ring;
  response_ring =  Jb_Ring_Init();
 

  /*
  {int count = 0;
   char test[20];
   xmlnode x, y;
   x =  xmlnode_new_tag("pipe_envelope");
   Ns_Log(Notice , "der xmlnode aus nsjabberstart 1 : \n %s" ,xmlnode2str(x)); 
  for(count = 0 ; count < 5 ; count++)
     {Ns_Log(Notice , "der xmlnode aus nsjabberstart 2 : \n %s", xmlnode_get_lastchild(x) );
            snprintf(test , 20 , "count = %d" , count);
      Ns_Log(Notice , "der xmlnode aus nsjabberstart 3 : \n" );
       xmlnode_insert_tag(x ,"sql");
       xmlnode_insert_cdata(xmlnode_get_lastchild(x) , test , -1);
      Ns_Log(Notice , "der xmlnode aus nsjabberstart 4 : \n %s" ,xmlnode2str(x));
        
     }

   Ns_Log(Notice , "der xmlnode aus nsjabberstart : \n %s" ,xmlnode2str(x));
 
}
  */
    Jb_DbPipeStartupInit(InitPipePoolSize , InitPipeInterval);
  // initialising our Pipe to the db

 //cleanup our online db
 // JABBERCleanUp();

  //Start a new thread that waits till the Server is up, to do several things cleanup and other stuff
  Ns_BeginDetachedThread( Jb_Startup , NULL);

  return NS_OK;
} 





































